module: ir-protocol

define constant CORBA/<ScopedName> = CORBA/<string>;

define constant CORBA/<DefinitionKind> = one-of(#"dk-none", #"dk-all", #"dk-Attribute", #"dk-Constant", #"dk-Exception", #"dk-Interface", #"dk-Module", #"dk-Operation", #"dk-Typedef", #"dk-Alias", #"dk-Struct", #"dk-Union", #"dk-Enum", #"dk-Primitive", #"dk-String", #"dk-Sequence", #"dk-Array", #"dk-Repository", #"dk-Wstring", #"dk-Fixed");

define generic CORBA/DefinitionKind/successor (symbol :: CORBA/<DefinitionKind>)
 => (succ :: CORBA/<DefinitionKind>);

define generic CORBA/DefinitionKind/predecessor (symbol :: CORBA/<DefinitionKind>)
 => (pred :: CORBA/<DefinitionKind>);

define generic CORBA/DefinitionKind/< (lesser :: CORBA/<DefinitionKind>, greater :: CORBA/<DefinitionKind>)
 => (lesser? :: <boolean>);

define generic CORBA/DefinitionKind/> (greater :: CORBA/<DefinitionKind>, lesser :: CORBA/<DefinitionKind>)
 => (greater? :: <boolean>);

define constant CORBA/$DefinitionKind-typecode = make(<enum-typecode>, type: CORBA/<DefinitionKind>, name: "DefinitionKind", repository-id: "IDL:omg.org/CORBA/DefinitionKind:1.0", members: vector(#"dk-none", #"dk-all", #"dk-Attribute", #"dk-Constant", #"dk-Exception", #"dk-Interface", #"dk-Module", #"dk-Operation", #"dk-Typedef", #"dk-Alias", #"dk-Struct", #"dk-Union", #"dk-Enum", #"dk-Primitive", #"dk-String", #"dk-Sequence", #"dk-Array", #"dk-Repository", #"dk-Wstring", #"dk-Fixed"));

define method class-typecode (class == CORBA/<DefinitionKind>)
 => (typecode :: <enum-typecode>)
  CORBA/$DefinitionKind-typecode;
end method;

define sideways method object-typecode (object :: CORBA/<DefinitionKind>)
 => (typecode :: <enum-typecode>)
  CORBA/$DefinitionKind-typecode;
end method;

define inline-only function CORBA/DefinitionKind/as-symbol (integer :: <integer>)
 => (symbol :: CORBA/<DefinitionKind>)
  let typecode = class-typecode(CORBA/<DefinitionKind>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CORBA/DefinitionKind/as-integer (symbol :: CORBA/<DefinitionKind>)
 => (integer :: <integer>)
  let typecode = class-typecode(CORBA/<DefinitionKind>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CORBA/DefinitionKind/successor (symbol :: CORBA/<DefinitionKind>)
 => (succ :: CORBA/<DefinitionKind>)
  let i = CORBA/DefinitionKind/as-integer(symbol);
  CORBA/DefinitionKind/as-symbol(modulo(i + 1, 20));
end method;

define method CORBA/DefinitionKind/predecessor (symbol :: CORBA/<DefinitionKind>)
 => (pred :: CORBA/<DefinitionKind>)
  let i = CORBA/DefinitionKind/as-integer(symbol);
  CORBA/DefinitionKind/as-symbol(modulo(20 + i - 1, 20));
end method;

define method CORBA/DefinitionKind/< (lesser :: CORBA/<DefinitionKind>, greater :: CORBA/<DefinitionKind>)
 => (lesser? :: <boolean>)
  CORBA/DefinitionKind/as-integer(lesser) < CORBA/DefinitionKind/as-integer(greater);
end method;

define method CORBA/DefinitionKind/> (greater :: CORBA/<DefinitionKind>, lesser :: CORBA/<DefinitionKind>)
 => (greater? :: <boolean>)
  CORBA/DefinitionKind/as-integer(greater) > CORBA/DefinitionKind/as-integer(lesser);
end method;

define open abstract class CORBA/<IRObject> (<object>)
end class;

define method class-typecode (class :: subclass(CORBA/<IRObject>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$IRObject-typecode;
end method;

define method object-typecode (object :: CORBA/<IRObject>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$IRObject-typecode;
end method;

define constant CORBA/$IRObject-typecode = make(<object-reference-typecode>, type: CORBA/<IRObject>, name: "IRObject", repository-id: "IDL:omg.org/CORBA/IRObject:1.0");

define open generic CORBA/IRObject/def-kind (object :: CORBA/<IRObject>)
 => (result :: CORBA/<DefinitionKind>);

define open generic CORBA/IRObject/destroy (object :: CORBA/<IRObject>)
 => ();

define constant CORBA/<VersionSpec> = CORBA/<string>;

define constant CORBA/$Contained-typecode = make(<object-reference-typecode>, type: CORBA/<Contained>, name: "Contained", repository-id: "IDL:omg.org/CORBA/Contained:1.0");

define open abstract class CORBA/<Contained> (CORBA/<IRObject>)
end class;

define method class-typecode (class :: subclass(CORBA/<Contained>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$Contained-typecode;
end method;

define method object-typecode (object :: CORBA/<Contained>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$Contained-typecode;
end method;

define constant CORBA/$Repository-typecode = make(<object-reference-typecode>, type: CORBA/<Repository>, name: "Repository", repository-id: "IDL:omg.org/CORBA/Repository:1.0");

define open abstract class CORBA/<Repository> (CORBA/<Container>)
end class;

define method class-typecode (class :: subclass(CORBA/<Repository>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$Repository-typecode;
end method;

define method object-typecode (object :: CORBA/<Repository>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$Repository-typecode;
end method;

define constant CORBA/$Container-typecode = make(<object-reference-typecode>, type: CORBA/<Container>, name: "Container", repository-id: "IDL:omg.org/CORBA/Container:1.0");

define open abstract class CORBA/<Container> (CORBA/<IRObject>)
end class;

define method class-typecode (class :: subclass(CORBA/<Container>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$Container-typecode;
end method;

define method object-typecode (object :: CORBA/<Container>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$Container-typecode;
end method;

define constant CORBA/$ExceptionDef-typecode = make(<object-reference-typecode>, type: CORBA/<ExceptionDef>, name: "ExceptionDef", repository-id: "IDL:omg.org/CORBA/ExceptionDef:1.0");

define open abstract class CORBA/<ExceptionDef> (CORBA/<Contained>, CORBA/<Container>)
end class;

define method class-typecode (class :: subclass(CORBA/<ExceptionDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$ExceptionDef-typecode;
end method;

define method object-typecode (object :: CORBA/<ExceptionDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$ExceptionDef-typecode;
end method;

define constant CORBA/$WstringDef-typecode = make(<object-reference-typecode>, type: CORBA/<WstringDef>, name: "WstringDef", repository-id: "IDL:omg.org/CORBA/WstringDef:1.0");

define open abstract class CORBA/<WstringDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<WstringDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$WstringDef-typecode;
end method;

define method object-typecode (object :: CORBA/<WstringDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$WstringDef-typecode;
end method;

define constant CORBA/$FixedDef-typecode = make(<object-reference-typecode>, type: CORBA/<FixedDef>, name: "FixedDef", repository-id: "IDL:omg.org/CORBA/FixedDef:1.0");

define open abstract class CORBA/<FixedDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<FixedDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$FixedDef-typecode;
end method;

define method object-typecode (object :: CORBA/<FixedDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$FixedDef-typecode;
end method;

define open generic CORBA/Contained/id (object :: CORBA/<Contained>)
 => (result :: CORBA/<RepositoryId>);

define open generic CORBA/Contained/id-setter (new-value :: CORBA/<RepositoryId>, object :: CORBA/<Contained>)
 => (result :: CORBA/<RepositoryId>);

define open generic CORBA/Contained/name (object :: CORBA/<Contained>)
 => (result :: CORBA/<Identifier>);

define open generic CORBA/Contained/name-setter (new-value :: CORBA/<Identifier>, object :: CORBA/<Contained>)
 => (result :: CORBA/<Identifier>);

define open generic CORBA/Contained/version (object :: CORBA/<Contained>)
 => (result :: CORBA/<VersionSpec>);

define open generic CORBA/Contained/version-setter (new-value :: CORBA/<VersionSpec>, object :: CORBA/<Contained>)
 => (result :: CORBA/<VersionSpec>);

define open generic CORBA/Contained/defined-in (object :: CORBA/<Contained>)
 => (result :: CORBA/<Container>);

define open generic CORBA/Contained/absolute-name (object :: CORBA/<Contained>)
 => (result :: CORBA/<ScopedName>);

define open generic CORBA/Contained/containing-repository (object :: CORBA/<Contained>)
 => (result :: CORBA/<Repository>);

define sealed class CORBA/Contained/<Description> (CORBA/<struct>)
  slot CORBA/Contained/Description/kind :: CORBA/<DefinitionKind>, required-init-keyword: kind:;
  slot CORBA/Contained/Description/value :: CORBA/<any>, required-init-keyword: value:;
end class;
define sealed domain make (singleton(CORBA/Contained/<Description>));
define sealed domain initialize (CORBA/Contained/<Description>);

define constant CORBA/Contained/$Description-typecode = make(<struct-typecode>, type: CORBA/Contained/<Description>, name: "Description", repository-id: "IDL:omg.org/CORBA/Contained/Description:1.0", members: vector(make(<typecode-member>, name: "kind", type: CORBA/<DefinitionKind>, getter: CORBA/Contained/Description/kind, setter: CORBA/Contained/Description/kind-setter, init-keyword: kind:, typecode: class-typecode(CORBA/<DefinitionKind>)), make(<typecode-member>, name: "value", type: CORBA/<any>, getter: CORBA/Contained/Description/value, setter: CORBA/Contained/Description/value-setter, init-keyword: value:, typecode: make(<any-typecode>))));

define method class-typecode (class == CORBA/Contained/<Description>)
 => (typecode :: <struct-typecode>)
  CORBA/Contained/$Description-typecode;
end method;

define method object-typecode (object :: CORBA/Contained/<Description>)
 => (typecode :: <struct-typecode>)
  CORBA/Contained/$Description-typecode;
end method;

define open generic CORBA/Contained/describe (object :: CORBA/<Contained>)
 => (result :: CORBA/Contained/<Description>);

define open generic CORBA/Contained/move (object :: CORBA/<Contained>, new-container :: CORBA/<Container>, new-name :: CORBA/<Identifier>, new-version :: CORBA/<VersionSpec>)
 => ();

define constant CORBA/$ModuleDef-typecode = make(<object-reference-typecode>, type: CORBA/<ModuleDef>, name: "ModuleDef", repository-id: "IDL:omg.org/CORBA/ModuleDef:1.0");

define open abstract class CORBA/<ModuleDef> (CORBA/<Contained>, CORBA/<Container>)
end class;

define method class-typecode (class :: subclass(CORBA/<ModuleDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$ModuleDef-typecode;
end method;

define method object-typecode (object :: CORBA/<ModuleDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$ModuleDef-typecode;
end method;

define constant CORBA/$ConstantDef-typecode = make(<object-reference-typecode>, type: CORBA/<ConstantDef>, name: "ConstantDef", repository-id: "IDL:omg.org/CORBA/ConstantDef:1.0");

define open abstract class CORBA/<ConstantDef> (CORBA/<Contained>)
end class;

define method class-typecode (class :: subclass(CORBA/<ConstantDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$ConstantDef-typecode;
end method;

define method object-typecode (object :: CORBA/<ConstantDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$ConstantDef-typecode;
end method;

define constant CORBA/$IDLType-typecode = make(<object-reference-typecode>, type: CORBA/<IDLType>, name: "IDLType", repository-id: "IDL:omg.org/CORBA/IDLType:1.0");

define open abstract class CORBA/<IDLType> (CORBA/<IRObject>)
end class;

define method class-typecode (class :: subclass(CORBA/<IDLType>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$IDLType-typecode;
end method;

define method object-typecode (object :: CORBA/<IDLType>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$IDLType-typecode;
end method;

define constant CORBA/$StructDef-typecode = make(<object-reference-typecode>, type: CORBA/<StructDef>, name: "StructDef", repository-id: "IDL:omg.org/CORBA/StructDef:1.0");

define open abstract class CORBA/<StructDef> (CORBA/<Container>, CORBA/<TypedefDef>)
end class;

define method class-typecode (class :: subclass(CORBA/<StructDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$StructDef-typecode;
end method;

define method object-typecode (object :: CORBA/<StructDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$StructDef-typecode;
end method;

define constant CORBA/$UnionDef-typecode = make(<object-reference-typecode>, type: CORBA/<UnionDef>, name: "UnionDef", repository-id: "IDL:omg.org/CORBA/UnionDef:1.0");

define open abstract class CORBA/<UnionDef> (CORBA/<Container>, CORBA/<TypedefDef>)
end class;

define method class-typecode (class :: subclass(CORBA/<UnionDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$UnionDef-typecode;
end method;

define method object-typecode (object :: CORBA/<UnionDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$UnionDef-typecode;
end method;

define constant CORBA/$EnumDef-typecode = make(<object-reference-typecode>, type: CORBA/<EnumDef>, name: "EnumDef", repository-id: "IDL:omg.org/CORBA/EnumDef:1.0");

define open abstract class CORBA/<EnumDef> (CORBA/<TypedefDef>)
end class;

define method class-typecode (class :: subclass(CORBA/<EnumDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$EnumDef-typecode;
end method;

define method object-typecode (object :: CORBA/<EnumDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$EnumDef-typecode;
end method;

define constant CORBA/$AliasDef-typecode = make(<object-reference-typecode>, type: CORBA/<AliasDef>, name: "AliasDef", repository-id: "IDL:omg.org/CORBA/AliasDef:1.0");

define open abstract class CORBA/<AliasDef> (CORBA/<TypedefDef>)
end class;

define method class-typecode (class :: subclass(CORBA/<AliasDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$AliasDef-typecode;
end method;

define method object-typecode (object :: CORBA/<AliasDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$AliasDef-typecode;
end method;

define constant CORBA/$InterfaceDef-typecode = make(<object-reference-typecode>, type: CORBA/<InterfaceDef>, name: "InterfaceDef", repository-id: "IDL:omg.org/CORBA/InterfaceDef:1.0");

define open abstract class CORBA/<InterfaceDef> (CORBA/<Contained>, CORBA/<Container>, CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<InterfaceDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$InterfaceDef-typecode;
end method;

define method object-typecode (object :: CORBA/<InterfaceDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$InterfaceDef-typecode;
end method;

define constant CORBA/<InterfaceDefSeq> = limited(CORBA/<sequence>, of: CORBA/<InterfaceDef>);

define constant CORBA/<ContainedSeq> = limited(CORBA/<sequence>, of: CORBA/<Contained>);

define sealed class CORBA/<StructMember> (CORBA/<struct>)
  slot CORBA/StructMember/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/StructMember/type :: CORBA/<TypeCode>, required-init-keyword: type:;
  slot CORBA/StructMember/type-def :: CORBA/<IDLType>, required-init-keyword: type-def:;
end class;
define sealed domain make (singleton(CORBA/<StructMember>));
define sealed domain initialize (CORBA/<StructMember>);

define constant CORBA/$StructMember-typecode = make(<struct-typecode>, type: CORBA/<StructMember>, name: "StructMember", repository-id: "IDL:omg.org/CORBA/StructMember:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/StructMember/name, setter: CORBA/StructMember/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/StructMember/type, setter: CORBA/StructMember/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "type_def", type: CORBA/<IDLType>, getter: CORBA/StructMember/type-def, setter: CORBA/StructMember/type-def-setter, init-keyword: type-def:, typecode: class-typecode(CORBA/<IDLType>))));

define method class-typecode (class == CORBA/<StructMember>)
 => (typecode :: <struct-typecode>)
  CORBA/$StructMember-typecode;
end method;

define method object-typecode (object :: CORBA/<StructMember>)
 => (typecode :: <struct-typecode>)
  CORBA/$StructMember-typecode;
end method;

define constant CORBA/<StructMemberSeq> = limited(CORBA/<sequence>, of: CORBA/<StructMember>);

define sealed class CORBA/<UnionMember> (CORBA/<struct>)
  slot CORBA/UnionMember/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/UnionMember/label :: CORBA/<any>, required-init-keyword: label:;
  slot CORBA/UnionMember/type :: CORBA/<TypeCode>, required-init-keyword: type:;
  slot CORBA/UnionMember/type-def :: CORBA/<IDLType>, required-init-keyword: type-def:;
end class;
define sealed domain make (singleton(CORBA/<UnionMember>));
define sealed domain initialize (CORBA/<UnionMember>);

define constant CORBA/$UnionMember-typecode = make(<struct-typecode>, type: CORBA/<UnionMember>, name: "UnionMember", repository-id: "IDL:omg.org/CORBA/UnionMember:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/UnionMember/name, setter: CORBA/UnionMember/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "label", type: CORBA/<any>, getter: CORBA/UnionMember/label, setter: CORBA/UnionMember/label-setter, init-keyword: label:, typecode: make(<any-typecode>)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/UnionMember/type, setter: CORBA/UnionMember/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "type_def", type: CORBA/<IDLType>, getter: CORBA/UnionMember/type-def, setter: CORBA/UnionMember/type-def-setter, init-keyword: type-def:, typecode: class-typecode(CORBA/<IDLType>))));

define method class-typecode (class == CORBA/<UnionMember>)
 => (typecode :: <struct-typecode>)
  CORBA/$UnionMember-typecode;
end method;

define method object-typecode (object :: CORBA/<UnionMember>)
 => (typecode :: <struct-typecode>)
  CORBA/$UnionMember-typecode;
end method;

define constant CORBA/<UnionMemberSeq> = limited(CORBA/<sequence>, of: CORBA/<UnionMember>);

define constant CORBA/<EnumMemberSeq> = limited(CORBA/<sequence>, of: CORBA/<Identifier>);

define open generic CORBA/Container/lookup (object :: CORBA/<Container>, search-name :: CORBA/<ScopedName>)
 => (result :: CORBA/<Contained>);

define open generic CORBA/Container/contents (object :: CORBA/<Container>, limit-type :: CORBA/<DefinitionKind>, exclude-inherited :: CORBA/<boolean>)
 => (result :: CORBA/<ContainedSeq>);

define open generic CORBA/Container/lookup-name (object :: CORBA/<Container>, search-name :: CORBA/<Identifier>, levels-to-search :: CORBA/<long>, limit-type :: CORBA/<DefinitionKind>, exclude-inherited :: CORBA/<boolean>)
 => (result :: CORBA/<ContainedSeq>);

define sealed class CORBA/Container/<Description> (CORBA/<struct>)
  slot CORBA/Container/Description/contained-object :: CORBA/<Contained>, required-init-keyword: contained-object:;
  slot CORBA/Container/Description/kind :: CORBA/<DefinitionKind>, required-init-keyword: kind:;
  slot CORBA/Container/Description/value :: CORBA/<any>, required-init-keyword: value:;
end class;
define sealed domain make (singleton(CORBA/Container/<Description>));
define sealed domain initialize (CORBA/Container/<Description>);

define constant CORBA/Container/$Description-typecode = make(<struct-typecode>, type: CORBA/Container/<Description>, name: "Description", repository-id: "IDL:omg.org/CORBA/Container/Description:1.0", members: vector(make(<typecode-member>, name: "contained_object", type: CORBA/<Contained>, getter: CORBA/Container/Description/contained-object, setter: CORBA/Container/Description/contained-object-setter, init-keyword: contained-object:, typecode: class-typecode(CORBA/<Contained>)), make(<typecode-member>, name: "kind", type: CORBA/<DefinitionKind>, getter: CORBA/Container/Description/kind, setter: CORBA/Container/Description/kind-setter, init-keyword: kind:, typecode: class-typecode(CORBA/<DefinitionKind>)), make(<typecode-member>, name: "value", type: CORBA/<any>, getter: CORBA/Container/Description/value, setter: CORBA/Container/Description/value-setter, init-keyword: value:, typecode: make(<any-typecode>))));

define method class-typecode (class == CORBA/Container/<Description>)
 => (typecode :: <struct-typecode>)
  CORBA/Container/$Description-typecode;
end method;

define method object-typecode (object :: CORBA/Container/<Description>)
 => (typecode :: <struct-typecode>)
  CORBA/Container/$Description-typecode;
end method;

define constant CORBA/Container/<DescriptionSeq> = limited(CORBA/<sequence>, of: CORBA/Container/<Description>);

define open generic CORBA/Container/describe-contents (object :: CORBA/<Container>, limit-type :: CORBA/<DefinitionKind>, exclude-inherited :: CORBA/<boolean>, max-returned-objs :: CORBA/<long>)
 => (result :: CORBA/Container/<DescriptionSeq>);

define open generic CORBA/Container/create-module (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>)
 => (result :: CORBA/<ModuleDef>);

define open generic CORBA/Container/create-constant (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, type :: CORBA/<IDLType>, value :: CORBA/<any>)
 => (result :: CORBA/<ConstantDef>);

define open generic CORBA/Container/create-struct (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, members :: CORBA/<StructMemberSeq>)
 => (result :: CORBA/<StructDef>);

define open generic CORBA/Container/create-union (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, discriminator-type :: CORBA/<IDLType>, members :: CORBA/<UnionMemberSeq>)
 => (result :: CORBA/<UnionDef>);

define open generic CORBA/Container/create-enum (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, members :: CORBA/<EnumMemberSeq>)
 => (result :: CORBA/<EnumDef>);

define open generic CORBA/Container/create-alias (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, original-type :: CORBA/<IDLType>)
 => (result :: CORBA/<AliasDef>);

define open generic CORBA/Container/create-interface (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, base-interfaces :: CORBA/<InterfaceDefSeq>)
 => (result :: CORBA/<InterfaceDef>);

define open generic CORBA/Container/create-exception (object :: CORBA/<Container>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, members :: CORBA/<StructMemberSeq>)
 => (result :: CORBA/<ExceptionDef>);

define open generic CORBA/IDLType/type (object :: CORBA/<IDLType>)
 => (result :: CORBA/<TypeCode>);

define constant CORBA/$PrimitiveDef-typecode = make(<object-reference-typecode>, type: CORBA/<PrimitiveDef>, name: "PrimitiveDef", repository-id: "IDL:omg.org/CORBA/PrimitiveDef:1.0");

define open abstract class CORBA/<PrimitiveDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<PrimitiveDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$PrimitiveDef-typecode;
end method;

define method object-typecode (object :: CORBA/<PrimitiveDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$PrimitiveDef-typecode;
end method;

define constant CORBA/$StringDef-typecode = make(<object-reference-typecode>, type: CORBA/<StringDef>, name: "StringDef", repository-id: "IDL:omg.org/CORBA/StringDef:1.0");

define open abstract class CORBA/<StringDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<StringDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$StringDef-typecode;
end method;

define method object-typecode (object :: CORBA/<StringDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$StringDef-typecode;
end method;

define constant CORBA/$SequenceDef-typecode = make(<object-reference-typecode>, type: CORBA/<SequenceDef>, name: "SequenceDef", repository-id: "IDL:omg.org/CORBA/SequenceDef:1.0");

define open abstract class CORBA/<SequenceDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<SequenceDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$SequenceDef-typecode;
end method;

define method object-typecode (object :: CORBA/<SequenceDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$SequenceDef-typecode;
end method;

define constant CORBA/$ArrayDef-typecode = make(<object-reference-typecode>, type: CORBA/<ArrayDef>, name: "ArrayDef", repository-id: "IDL:omg.org/CORBA/ArrayDef:1.0");

define open abstract class CORBA/<ArrayDef> (CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<ArrayDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$ArrayDef-typecode;
end method;

define method object-typecode (object :: CORBA/<ArrayDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$ArrayDef-typecode;
end method;

define constant CORBA/<PrimitiveKind> = one-of(#"pk-null", #"pk-void", #"pk-short", #"pk-long", #"pk-ushort", #"pk-ulong", #"pk-float", #"pk-double", #"pk-boolean", #"pk-char", #"pk-octet", #"pk-any", #"pk-TypeCode", #"pk-Principal", #"pk-string", #"pk-objref", #"pk-longlong", #"pk-ulonglong", #"pk-longdouble", #"pk-wchar", #"pk-wstring");

define generic CORBA/PrimitiveKind/successor (symbol :: CORBA/<PrimitiveKind>)
 => (succ :: CORBA/<PrimitiveKind>);

define generic CORBA/PrimitiveKind/predecessor (symbol :: CORBA/<PrimitiveKind>)
 => (pred :: CORBA/<PrimitiveKind>);

define generic CORBA/PrimitiveKind/< (lesser :: CORBA/<PrimitiveKind>, greater :: CORBA/<PrimitiveKind>)
 => (lesser? :: <boolean>);

define generic CORBA/PrimitiveKind/> (greater :: CORBA/<PrimitiveKind>, lesser :: CORBA/<PrimitiveKind>)
 => (greater? :: <boolean>);

define constant CORBA/$PrimitiveKind-typecode = make(<enum-typecode>, type: CORBA/<PrimitiveKind>, name: "PrimitiveKind", repository-id: "IDL:omg.org/CORBA/PrimitiveKind:1.0", members: vector(#"pk-null", #"pk-void", #"pk-short", #"pk-long", #"pk-ushort", #"pk-ulong", #"pk-float", #"pk-double", #"pk-boolean", #"pk-char", #"pk-octet", #"pk-any", #"pk-TypeCode", #"pk-Principal", #"pk-string", #"pk-objref", #"pk-longlong", #"pk-ulonglong", #"pk-longdouble", #"pk-wchar", #"pk-wstring"));

define method class-typecode (class == CORBA/<PrimitiveKind>)
 => (typecode :: <enum-typecode>)
  CORBA/$PrimitiveKind-typecode;
end method;

define sideways method object-typecode (object :: CORBA/<PrimitiveKind>)
 => (typecode :: <enum-typecode>)
  CORBA/$PrimitiveKind-typecode;
end method;

define inline-only function CORBA/PrimitiveKind/as-symbol (integer :: <integer>)
 => (symbol :: CORBA/<PrimitiveKind>)
  let typecode = class-typecode(CORBA/<PrimitiveKind>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CORBA/PrimitiveKind/as-integer (symbol :: CORBA/<PrimitiveKind>)
 => (integer :: <integer>)
  let typecode = class-typecode(CORBA/<PrimitiveKind>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CORBA/PrimitiveKind/successor (symbol :: CORBA/<PrimitiveKind>)
 => (succ :: CORBA/<PrimitiveKind>)
  let i = CORBA/PrimitiveKind/as-integer(symbol);
  CORBA/PrimitiveKind/as-symbol(modulo(i + 1, 21));
end method;

define method CORBA/PrimitiveKind/predecessor (symbol :: CORBA/<PrimitiveKind>)
 => (pred :: CORBA/<PrimitiveKind>)
  let i = CORBA/PrimitiveKind/as-integer(symbol);
  CORBA/PrimitiveKind/as-symbol(modulo(21 + i - 1, 21));
end method;

define method CORBA/PrimitiveKind/< (lesser :: CORBA/<PrimitiveKind>, greater :: CORBA/<PrimitiveKind>)
 => (lesser? :: <boolean>)
  CORBA/PrimitiveKind/as-integer(lesser) < CORBA/PrimitiveKind/as-integer(greater);
end method;

define method CORBA/PrimitiveKind/> (greater :: CORBA/<PrimitiveKind>, lesser :: CORBA/<PrimitiveKind>)
 => (greater? :: <boolean>)
  CORBA/PrimitiveKind/as-integer(greater) > CORBA/PrimitiveKind/as-integer(lesser);
end method;

define open generic CORBA/Repository/lookup-id (object :: CORBA/<Repository>, search-id :: CORBA/<RepositoryId>)
 => (result :: CORBA/<Contained>);

define open generic CORBA/Repository/get-primitive (object :: CORBA/<Repository>, kind :: CORBA/<PrimitiveKind>)
 => (result :: CORBA/<PrimitiveDef>);

define open generic CORBA/Repository/create-string (object :: CORBA/<Repository>, bound :: CORBA/<unsigned-long>)
 => (result :: CORBA/<StringDef>);

define open generic CORBA/Repository/create-wstring (object :: CORBA/<Repository>, bound :: CORBA/<unsigned-long>)
 => (result :: CORBA/<WstringDef>);

define open generic CORBA/Repository/create-sequence (object :: CORBA/<Repository>, bound :: CORBA/<unsigned-long>, element-type :: CORBA/<IDLType>)
 => (result :: CORBA/<SequenceDef>);

define open generic CORBA/Repository/create-array (object :: CORBA/<Repository>, length :: CORBA/<unsigned-long>, element-type :: CORBA/<IDLType>)
 => (result :: CORBA/<ArrayDef>);

define open generic CORBA/Repository/create-fixed (object :: CORBA/<Repository>, digits :: CORBA/<unsigned-short>, scale :: CORBA/<short>)
 => (result :: CORBA/<FixedDef>);

define sealed class CORBA/<ModuleDescription> (CORBA/<struct>)
  slot CORBA/ModuleDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/ModuleDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/ModuleDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/ModuleDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
end class;
define sealed domain make (singleton(CORBA/<ModuleDescription>));
define sealed domain initialize (CORBA/<ModuleDescription>);

define constant CORBA/$ModuleDescription-typecode = make(<struct-typecode>, type: CORBA/<ModuleDescription>, name: "ModuleDescription", repository-id: "IDL:omg.org/CORBA/ModuleDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/ModuleDescription/name, setter: CORBA/ModuleDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/ModuleDescription/id, setter: CORBA/ModuleDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/ModuleDescription/defined-in, setter: CORBA/ModuleDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/ModuleDescription/version, setter: CORBA/ModuleDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))));

define method class-typecode (class == CORBA/<ModuleDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ModuleDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<ModuleDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ModuleDescription-typecode;
end method;

define open generic CORBA/ConstantDef/type (object :: CORBA/<ConstantDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/ConstantDef/type-def (object :: CORBA/<ConstantDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/ConstantDef/type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<ConstantDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/ConstantDef/value (object :: CORBA/<ConstantDef>)
 => (result :: CORBA/<any>);

define open generic CORBA/ConstantDef/value-setter (new-value :: CORBA/<any>, object :: CORBA/<ConstantDef>)
 => (result :: CORBA/<any>);

define sealed class CORBA/<ConstantDescription> (CORBA/<struct>)
  slot CORBA/ConstantDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/ConstantDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/ConstantDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/ConstantDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/ConstantDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
  slot CORBA/ConstantDescription/value :: CORBA/<any>, required-init-keyword: value:;
end class;
define sealed domain make (singleton(CORBA/<ConstantDescription>));
define sealed domain initialize (CORBA/<ConstantDescription>);

define constant CORBA/$ConstantDescription-typecode = make(<struct-typecode>, type: CORBA/<ConstantDescription>, name: "ConstantDescription", repository-id: "IDL:omg.org/CORBA/ConstantDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/ConstantDescription/name, setter: CORBA/ConstantDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/ConstantDescription/id, setter: CORBA/ConstantDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/ConstantDescription/defined-in, setter: CORBA/ConstantDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/ConstantDescription/version, setter: CORBA/ConstantDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/ConstantDescription/type, setter: CORBA/ConstantDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "value", type: CORBA/<any>, getter: CORBA/ConstantDescription/value, setter: CORBA/ConstantDescription/value-setter, init-keyword: value:, typecode: make(<any-typecode>))));

define method class-typecode (class == CORBA/<ConstantDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ConstantDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<ConstantDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ConstantDescription-typecode;
end method;

define open abstract class CORBA/<TypedefDef> (CORBA/<Contained>, CORBA/<IDLType>)
end class;

define method class-typecode (class :: subclass(CORBA/<TypedefDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$TypedefDef-typecode;
end method;

define method object-typecode (object :: CORBA/<TypedefDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$TypedefDef-typecode;
end method;

define constant CORBA/$TypedefDef-typecode = make(<object-reference-typecode>, type: CORBA/<TypedefDef>, name: "TypedefDef", repository-id: "IDL:omg.org/CORBA/TypedefDef:1.0");

define sealed class CORBA/<TypeDescription> (CORBA/<struct>)
  slot CORBA/TypeDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/TypeDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/TypeDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/TypeDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/TypeDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
end class;
define sealed domain make (singleton(CORBA/<TypeDescription>));
define sealed domain initialize (CORBA/<TypeDescription>);

define constant CORBA/$TypeDescription-typecode = make(<struct-typecode>, type: CORBA/<TypeDescription>, name: "TypeDescription", repository-id: "IDL:omg.org/CORBA/TypeDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/TypeDescription/name, setter: CORBA/TypeDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/TypeDescription/id, setter: CORBA/TypeDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/TypeDescription/defined-in, setter: CORBA/TypeDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/TypeDescription/version, setter: CORBA/TypeDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/TypeDescription/type, setter: CORBA/TypeDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>))));

define method class-typecode (class == CORBA/<TypeDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$TypeDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<TypeDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$TypeDescription-typecode;
end method;

define open generic CORBA/StructDef/members (object :: CORBA/<StructDef>)
 => (result :: CORBA/<StructMemberSeq>);

define open generic CORBA/StructDef/members-setter (new-value :: CORBA/<StructMemberSeq>, object :: CORBA/<StructDef>)
 => (result :: CORBA/<StructMemberSeq>);

define open generic CORBA/UnionDef/discriminator-type (object :: CORBA/<UnionDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/UnionDef/discriminator-type-def (object :: CORBA/<UnionDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/UnionDef/discriminator-type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<UnionDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/UnionDef/members (object :: CORBA/<UnionDef>)
 => (result :: CORBA/<UnionMemberSeq>);

define open generic CORBA/UnionDef/members-setter (new-value :: CORBA/<UnionMemberSeq>, object :: CORBA/<UnionDef>)
 => (result :: CORBA/<UnionMemberSeq>);

define open generic CORBA/EnumDef/members (object :: CORBA/<EnumDef>)
 => (result :: CORBA/<EnumMemberSeq>);

define open generic CORBA/EnumDef/members-setter (new-value :: CORBA/<EnumMemberSeq>, object :: CORBA/<EnumDef>)
 => (result :: CORBA/<EnumMemberSeq>);

define open generic CORBA/AliasDef/original-type-def (object :: CORBA/<AliasDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/AliasDef/original-type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<AliasDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/PrimitiveDef/kind (object :: CORBA/<PrimitiveDef>)
 => (result :: CORBA/<PrimitiveKind>);

define open generic CORBA/StringDef/bound (object :: CORBA/<StringDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/StringDef/bound-setter (new-value :: CORBA/<unsigned-long>, object :: CORBA/<StringDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/WstringDef/bound (object :: CORBA/<WstringDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/WstringDef/bound-setter (new-value :: CORBA/<unsigned-long>, object :: CORBA/<WstringDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/FixedDef/digits (object :: CORBA/<FixedDef>)
 => (result :: CORBA/<unsigned-short>);

define open generic CORBA/FixedDef/digits-setter (new-value :: CORBA/<unsigned-short>, object :: CORBA/<FixedDef>)
 => (result :: CORBA/<unsigned-short>);

define open generic CORBA/FixedDef/scale (object :: CORBA/<FixedDef>)
 => (result :: CORBA/<short>);

define open generic CORBA/FixedDef/scale-setter (new-value :: CORBA/<short>, object :: CORBA/<FixedDef>)
 => (result :: CORBA/<short>);

define open generic CORBA/SequenceDef/bound (object :: CORBA/<SequenceDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/SequenceDef/bound-setter (new-value :: CORBA/<unsigned-long>, object :: CORBA/<SequenceDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/SequenceDef/element-type (object :: CORBA/<SequenceDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/SequenceDef/element-type-def (object :: CORBA/<SequenceDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/SequenceDef/element-type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<SequenceDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/ArrayDef/length (object :: CORBA/<ArrayDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/ArrayDef/length-setter (new-value :: CORBA/<unsigned-long>, object :: CORBA/<ArrayDef>)
 => (result :: CORBA/<unsigned-long>);

define open generic CORBA/ArrayDef/element-type (object :: CORBA/<ArrayDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/ArrayDef/element-type-def (object :: CORBA/<ArrayDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/ArrayDef/element-type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<ArrayDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/ExceptionDef/type (object :: CORBA/<ExceptionDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/ExceptionDef/members (object :: CORBA/<ExceptionDef>)
 => (result :: CORBA/<StructMemberSeq>);

define open generic CORBA/ExceptionDef/members-setter (new-value :: CORBA/<StructMemberSeq>, object :: CORBA/<ExceptionDef>)
 => (result :: CORBA/<StructMemberSeq>);

define sealed class CORBA/<ExceptionDescription> (CORBA/<struct>)
  slot CORBA/ExceptionDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/ExceptionDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/ExceptionDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/ExceptionDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/ExceptionDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
end class;
define sealed domain make (singleton(CORBA/<ExceptionDescription>));
define sealed domain initialize (CORBA/<ExceptionDescription>);

define constant CORBA/$ExceptionDescription-typecode = make(<struct-typecode>, type: CORBA/<ExceptionDescription>, name: "ExceptionDescription", repository-id: "IDL:omg.org/CORBA/ExceptionDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/ExceptionDescription/name, setter: CORBA/ExceptionDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/ExceptionDescription/id, setter: CORBA/ExceptionDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/ExceptionDescription/defined-in, setter: CORBA/ExceptionDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/ExceptionDescription/version, setter: CORBA/ExceptionDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/ExceptionDescription/type, setter: CORBA/ExceptionDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>))));

define method class-typecode (class == CORBA/<ExceptionDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ExceptionDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<ExceptionDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ExceptionDescription-typecode;
end method;

define constant CORBA/<AttributeMode> = one-of(#"ATTR-NORMAL", #"ATTR-READONLY");

define generic CORBA/AttributeMode/successor (symbol :: CORBA/<AttributeMode>)
 => (succ :: CORBA/<AttributeMode>);

define generic CORBA/AttributeMode/predecessor (symbol :: CORBA/<AttributeMode>)
 => (pred :: CORBA/<AttributeMode>);

define generic CORBA/AttributeMode/< (lesser :: CORBA/<AttributeMode>, greater :: CORBA/<AttributeMode>)
 => (lesser? :: <boolean>);

define generic CORBA/AttributeMode/> (greater :: CORBA/<AttributeMode>, lesser :: CORBA/<AttributeMode>)
 => (greater? :: <boolean>);

define constant CORBA/$AttributeMode-typecode = make(<enum-typecode>, type: CORBA/<AttributeMode>, name: "AttributeMode", repository-id: "IDL:omg.org/CORBA/AttributeMode:1.0", members: vector(#"ATTR-NORMAL", #"ATTR-READONLY"));

define method class-typecode (class == CORBA/<AttributeMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$AttributeMode-typecode;
end method;

define sideways method object-typecode (object :: CORBA/<AttributeMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$AttributeMode-typecode;
end method;

define inline-only function CORBA/AttributeMode/as-symbol (integer :: <integer>)
 => (symbol :: CORBA/<AttributeMode>)
  let typecode = class-typecode(CORBA/<AttributeMode>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CORBA/AttributeMode/as-integer (symbol :: CORBA/<AttributeMode>)
 => (integer :: <integer>)
  let typecode = class-typecode(CORBA/<AttributeMode>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CORBA/AttributeMode/successor (symbol :: CORBA/<AttributeMode>)
 => (succ :: CORBA/<AttributeMode>)
  let i = CORBA/AttributeMode/as-integer(symbol);
  CORBA/AttributeMode/as-symbol(modulo(i + 1, 2));
end method;

define method CORBA/AttributeMode/predecessor (symbol :: CORBA/<AttributeMode>)
 => (pred :: CORBA/<AttributeMode>)
  let i = CORBA/AttributeMode/as-integer(symbol);
  CORBA/AttributeMode/as-symbol(modulo(2 + i - 1, 2));
end method;

define method CORBA/AttributeMode/< (lesser :: CORBA/<AttributeMode>, greater :: CORBA/<AttributeMode>)
 => (lesser? :: <boolean>)
  CORBA/AttributeMode/as-integer(lesser) < CORBA/AttributeMode/as-integer(greater);
end method;

define method CORBA/AttributeMode/> (greater :: CORBA/<AttributeMode>, lesser :: CORBA/<AttributeMode>)
 => (greater? :: <boolean>)
  CORBA/AttributeMode/as-integer(greater) > CORBA/AttributeMode/as-integer(lesser);
end method;

define open abstract class CORBA/<AttributeDef> (CORBA/<Contained>)
end class;

define method class-typecode (class :: subclass(CORBA/<AttributeDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$AttributeDef-typecode;
end method;

define method object-typecode (object :: CORBA/<AttributeDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$AttributeDef-typecode;
end method;

define constant CORBA/$AttributeDef-typecode = make(<object-reference-typecode>, type: CORBA/<AttributeDef>, name: "AttributeDef", repository-id: "IDL:omg.org/CORBA/AttributeDef:1.0");

define open generic CORBA/AttributeDef/type (object :: CORBA/<AttributeDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/AttributeDef/type-def (object :: CORBA/<AttributeDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/AttributeDef/type-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<AttributeDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/AttributeDef/mode (object :: CORBA/<AttributeDef>)
 => (result :: CORBA/<AttributeMode>);

define open generic CORBA/AttributeDef/mode-setter (new-value :: CORBA/<AttributeMode>, object :: CORBA/<AttributeDef>)
 => (result :: CORBA/<AttributeMode>);

define sealed class CORBA/<AttributeDescription> (CORBA/<struct>)
  slot CORBA/AttributeDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/AttributeDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/AttributeDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/AttributeDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/AttributeDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
  slot CORBA/AttributeDescription/mode :: CORBA/<AttributeMode>, required-init-keyword: mode:;
end class;
define sealed domain make (singleton(CORBA/<AttributeDescription>));
define sealed domain initialize (CORBA/<AttributeDescription>);

define constant CORBA/$AttributeDescription-typecode = make(<struct-typecode>, type: CORBA/<AttributeDescription>, name: "AttributeDescription", repository-id: "IDL:omg.org/CORBA/AttributeDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/AttributeDescription/name, setter: CORBA/AttributeDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/AttributeDescription/id, setter: CORBA/AttributeDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/AttributeDescription/defined-in, setter: CORBA/AttributeDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/AttributeDescription/version, setter: CORBA/AttributeDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/AttributeDescription/type, setter: CORBA/AttributeDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "mode", type: CORBA/<AttributeMode>, getter: CORBA/AttributeDescription/mode, setter: CORBA/AttributeDescription/mode-setter, init-keyword: mode:, typecode: class-typecode(CORBA/<AttributeMode>))));

define method class-typecode (class == CORBA/<AttributeDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$AttributeDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<AttributeDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$AttributeDescription-typecode;
end method;

define constant CORBA/<OperationMode> = one-of(#"OP-NORMAL", #"OP-ONEWAY");

define generic CORBA/OperationMode/successor (symbol :: CORBA/<OperationMode>)
 => (succ :: CORBA/<OperationMode>);

define generic CORBA/OperationMode/predecessor (symbol :: CORBA/<OperationMode>)
 => (pred :: CORBA/<OperationMode>);

define generic CORBA/OperationMode/< (lesser :: CORBA/<OperationMode>, greater :: CORBA/<OperationMode>)
 => (lesser? :: <boolean>);

define generic CORBA/OperationMode/> (greater :: CORBA/<OperationMode>, lesser :: CORBA/<OperationMode>)
 => (greater? :: <boolean>);

define constant CORBA/$OperationMode-typecode = make(<enum-typecode>, type: CORBA/<OperationMode>, name: "OperationMode", repository-id: "IDL:omg.org/CORBA/OperationMode:1.0", members: vector(#"OP-NORMAL", #"OP-ONEWAY"));

define method class-typecode (class == CORBA/<OperationMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$OperationMode-typecode;
end method;

define sideways method object-typecode (object :: CORBA/<OperationMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$OperationMode-typecode;
end method;

define inline-only function CORBA/OperationMode/as-symbol (integer :: <integer>)
 => (symbol :: CORBA/<OperationMode>)
  let typecode = class-typecode(CORBA/<OperationMode>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CORBA/OperationMode/as-integer (symbol :: CORBA/<OperationMode>)
 => (integer :: <integer>)
  let typecode = class-typecode(CORBA/<OperationMode>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CORBA/OperationMode/successor (symbol :: CORBA/<OperationMode>)
 => (succ :: CORBA/<OperationMode>)
  let i = CORBA/OperationMode/as-integer(symbol);
  CORBA/OperationMode/as-symbol(modulo(i + 1, 2));
end method;

define method CORBA/OperationMode/predecessor (symbol :: CORBA/<OperationMode>)
 => (pred :: CORBA/<OperationMode>)
  let i = CORBA/OperationMode/as-integer(symbol);
  CORBA/OperationMode/as-symbol(modulo(2 + i - 1, 2));
end method;

define method CORBA/OperationMode/< (lesser :: CORBA/<OperationMode>, greater :: CORBA/<OperationMode>)
 => (lesser? :: <boolean>)
  CORBA/OperationMode/as-integer(lesser) < CORBA/OperationMode/as-integer(greater);
end method;

define method CORBA/OperationMode/> (greater :: CORBA/<OperationMode>, lesser :: CORBA/<OperationMode>)
 => (greater? :: <boolean>)
  CORBA/OperationMode/as-integer(greater) > CORBA/OperationMode/as-integer(lesser);
end method;

define constant CORBA/<ParameterMode> = one-of(#"PARAM-IN", #"PARAM-OUT", #"PARAM-INOUT");

define generic CORBA/ParameterMode/successor (symbol :: CORBA/<ParameterMode>)
 => (succ :: CORBA/<ParameterMode>);

define generic CORBA/ParameterMode/predecessor (symbol :: CORBA/<ParameterMode>)
 => (pred :: CORBA/<ParameterMode>);

define generic CORBA/ParameterMode/< (lesser :: CORBA/<ParameterMode>, greater :: CORBA/<ParameterMode>)
 => (lesser? :: <boolean>);

define generic CORBA/ParameterMode/> (greater :: CORBA/<ParameterMode>, lesser :: CORBA/<ParameterMode>)
 => (greater? :: <boolean>);

define constant CORBA/$ParameterMode-typecode = make(<enum-typecode>, type: CORBA/<ParameterMode>, name: "ParameterMode", repository-id: "IDL:omg.org/CORBA/ParameterMode:1.0", members: vector(#"PARAM-IN", #"PARAM-OUT", #"PARAM-INOUT"));

define method class-typecode (class == CORBA/<ParameterMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$ParameterMode-typecode;
end method;

define sideways method object-typecode (object :: CORBA/<ParameterMode>)
 => (typecode :: <enum-typecode>)
  CORBA/$ParameterMode-typecode;
end method;

define inline-only function CORBA/ParameterMode/as-symbol (integer :: <integer>)
 => (symbol :: CORBA/<ParameterMode>)
  let typecode = class-typecode(CORBA/<ParameterMode>);
  typecode-members(typecode)[integer];
end function;

define inline-only function CORBA/ParameterMode/as-integer (symbol :: CORBA/<ParameterMode>)
 => (integer :: <integer>)
  let typecode = class-typecode(CORBA/<ParameterMode>);
  typecode-symbol-index(typecode)[symbol];
end function;

define method CORBA/ParameterMode/successor (symbol :: CORBA/<ParameterMode>)
 => (succ :: CORBA/<ParameterMode>)
  let i = CORBA/ParameterMode/as-integer(symbol);
  CORBA/ParameterMode/as-symbol(modulo(i + 1, 3));
end method;

define method CORBA/ParameterMode/predecessor (symbol :: CORBA/<ParameterMode>)
 => (pred :: CORBA/<ParameterMode>)
  let i = CORBA/ParameterMode/as-integer(symbol);
  CORBA/ParameterMode/as-symbol(modulo(3 + i - 1, 3));
end method;

define method CORBA/ParameterMode/< (lesser :: CORBA/<ParameterMode>, greater :: CORBA/<ParameterMode>)
 => (lesser? :: <boolean>)
  CORBA/ParameterMode/as-integer(lesser) < CORBA/ParameterMode/as-integer(greater);
end method;

define method CORBA/ParameterMode/> (greater :: CORBA/<ParameterMode>, lesser :: CORBA/<ParameterMode>)
 => (greater? :: <boolean>)
  CORBA/ParameterMode/as-integer(greater) > CORBA/ParameterMode/as-integer(lesser);
end method;

define sealed class CORBA/<ParameterDescription> (CORBA/<struct>)
  slot CORBA/ParameterDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/ParameterDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
  slot CORBA/ParameterDescription/type-def :: CORBA/<IDLType>, required-init-keyword: type-def:;
  slot CORBA/ParameterDescription/mode :: CORBA/<ParameterMode>, required-init-keyword: mode:;
end class;
define sealed domain make (singleton(CORBA/<ParameterDescription>));
define sealed domain initialize (CORBA/<ParameterDescription>);

define constant CORBA/$ParameterDescription-typecode = make(<struct-typecode>, type: CORBA/<ParameterDescription>, name: "ParameterDescription", repository-id: "IDL:omg.org/CORBA/ParameterDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/ParameterDescription/name, setter: CORBA/ParameterDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/ParameterDescription/type, setter: CORBA/ParameterDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "type_def", type: CORBA/<IDLType>, getter: CORBA/ParameterDescription/type-def, setter: CORBA/ParameterDescription/type-def-setter, init-keyword: type-def:, typecode: class-typecode(CORBA/<IDLType>)), make(<typecode-member>, name: "mode", type: CORBA/<ParameterMode>, getter: CORBA/ParameterDescription/mode, setter: CORBA/ParameterDescription/mode-setter, init-keyword: mode:, typecode: class-typecode(CORBA/<ParameterMode>))));

define method class-typecode (class == CORBA/<ParameterDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ParameterDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<ParameterDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$ParameterDescription-typecode;
end method;

define constant CORBA/<ParDescriptionSeq> = limited(CORBA/<sequence>, of: CORBA/<ParameterDescription>);

define constant CORBA/<ContextIdentifier> = CORBA/<Identifier>;

define constant CORBA/<ContextIdSeq> = limited(CORBA/<sequence>, of: CORBA/<ContextIdentifier>);

define constant CORBA/<ExceptionDefSeq> = limited(CORBA/<sequence>, of: CORBA/<ExceptionDef>);

define constant CORBA/<ExcDescriptionSeq> = limited(CORBA/<sequence>, of: CORBA/<ExceptionDescription>);

define open abstract class CORBA/<OperationDef> (CORBA/<Contained>)
end class;

define method class-typecode (class :: subclass(CORBA/<OperationDef>))
 => (typecode :: <object-reference-typecode>)
  CORBA/$OperationDef-typecode;
end method;

define method object-typecode (object :: CORBA/<OperationDef>)
 => (typecode :: <object-reference-typecode>)
  CORBA/$OperationDef-typecode;
end method;

define constant CORBA/$OperationDef-typecode = make(<object-reference-typecode>, type: CORBA/<OperationDef>, name: "OperationDef", repository-id: "IDL:omg.org/CORBA/OperationDef:1.0");

define open generic CORBA/OperationDef/result (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<TypeCode>);

define open generic CORBA/OperationDef/result-def (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/OperationDef/result-def-setter (new-value :: CORBA/<IDLType>, object :: CORBA/<OperationDef>)
 => (result :: CORBA/<IDLType>);

define open generic CORBA/OperationDef/params (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ParDescriptionSeq>);

define open generic CORBA/OperationDef/params-setter (new-value :: CORBA/<ParDescriptionSeq>, object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ParDescriptionSeq>);

define open generic CORBA/OperationDef/mode (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<OperationMode>);

define open generic CORBA/OperationDef/mode-setter (new-value :: CORBA/<OperationMode>, object :: CORBA/<OperationDef>)
 => (result :: CORBA/<OperationMode>);

define open generic CORBA/OperationDef/contexts (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ContextIdSeq>);

define open generic CORBA/OperationDef/contexts-setter (new-value :: CORBA/<ContextIdSeq>, object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ContextIdSeq>);

define open generic CORBA/OperationDef/exceptions (object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ExceptionDefSeq>);

define open generic CORBA/OperationDef/exceptions-setter (new-value :: CORBA/<ExceptionDefSeq>, object :: CORBA/<OperationDef>)
 => (result :: CORBA/<ExceptionDefSeq>);

define sealed class CORBA/<OperationDescription> (CORBA/<struct>)
  slot CORBA/OperationDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/OperationDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/OperationDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/OperationDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/OperationDescription/result :: CORBA/<TypeCode>, required-init-keyword: result:;
  slot CORBA/OperationDescription/mode :: CORBA/<OperationMode>, required-init-keyword: mode:;
  slot CORBA/OperationDescription/contexts :: CORBA/<ContextIdSeq>, required-init-keyword: contexts:;
  slot CORBA/OperationDescription/parameters :: CORBA/<ParDescriptionSeq>, required-init-keyword: parameters:;
  slot CORBA/OperationDescription/exceptions :: CORBA/<ExcDescriptionSeq>, required-init-keyword: exceptions:;
end class;
define sealed domain make (singleton(CORBA/<OperationDescription>));
define sealed domain initialize (CORBA/<OperationDescription>);

define constant CORBA/$OperationDescription-typecode = make(<struct-typecode>, type: CORBA/<OperationDescription>, name: "OperationDescription", repository-id: "IDL:omg.org/CORBA/OperationDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/OperationDescription/name, setter: CORBA/OperationDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/OperationDescription/id, setter: CORBA/OperationDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/OperationDescription/defined-in, setter: CORBA/OperationDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/OperationDescription/version, setter: CORBA/OperationDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "result", type: CORBA/<TypeCode>, getter: CORBA/OperationDescription/result, setter: CORBA/OperationDescription/result-setter, init-keyword: result:, typecode: class-typecode(CORBA/<TypeCode>)), make(<typecode-member>, name: "mode", type: CORBA/<OperationMode>, getter: CORBA/OperationDescription/mode, setter: CORBA/OperationDescription/mode-setter, init-keyword: mode:, typecode: class-typecode(CORBA/<OperationMode>)), make(<typecode-member>, name: "contexts", type: CORBA/<ContextIdSeq>, getter: CORBA/OperationDescription/contexts, setter: CORBA/OperationDescription/contexts-setter, init-keyword: contexts:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<ContextIdentifier>), type: limited(CORBA/<sequence>, of: CORBA/<ContextIdentifier>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))), make(<typecode-member>, name: "parameters", type: CORBA/<ParDescriptionSeq>, getter: CORBA/OperationDescription/parameters, setter: CORBA/OperationDescription/parameters-setter, init-keyword: parameters:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<ParameterDescription>), type: limited(CORBA/<sequence>, of: CORBA/<ParameterDescription>), max-length: 0, element-typecode: class-typecode(CORBA/<ParameterDescription>))), make(<typecode-member>, name: "exceptions", type: CORBA/<ExcDescriptionSeq>, getter: CORBA/OperationDescription/exceptions, setter: CORBA/OperationDescription/exceptions-setter, init-keyword: exceptions:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<ExceptionDescription>), type: limited(CORBA/<sequence>, of: CORBA/<ExceptionDescription>), max-length: 0, element-typecode: class-typecode(CORBA/<ExceptionDescription>)))));

define method class-typecode (class == CORBA/<OperationDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$OperationDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<OperationDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$OperationDescription-typecode;
end method;

define constant CORBA/<RepositoryIdSeq> = limited(CORBA/<sequence>, of: CORBA/<RepositoryId>);

define constant CORBA/<OpDescriptionSeq> = limited(CORBA/<sequence>, of: CORBA/<OperationDescription>);

define constant CORBA/<AttrDescriptionSeq> = limited(CORBA/<sequence>, of: CORBA/<AttributeDescription>);

define open generic CORBA/InterfaceDef/base-interfaces (object :: CORBA/<InterfaceDef>)
 => (result :: CORBA/<InterfaceDefSeq>);

define open generic CORBA/InterfaceDef/base-interfaces-setter (new-value :: CORBA/<InterfaceDefSeq>, object :: CORBA/<InterfaceDef>)
 => (result :: CORBA/<InterfaceDefSeq>);

define open generic CORBA/InterfaceDef/is-a (object :: CORBA/<InterfaceDef>, interface-id :: CORBA/<RepositoryId>)
 => (result :: CORBA/<boolean>);

define sealed class CORBA/InterfaceDef/<FullInterfaceDescription> (CORBA/<struct>)
  slot CORBA/InterfaceDef/FullInterfaceDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/operations :: CORBA/<OpDescriptionSeq>, required-init-keyword: operations:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/attributes :: CORBA/<AttrDescriptionSeq>, required-init-keyword: attributes:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/base-interfaces :: CORBA/<RepositoryIdSeq>, required-init-keyword: base-interfaces:;
  slot CORBA/InterfaceDef/FullInterfaceDescription/type :: CORBA/<TypeCode>, required-init-keyword: type:;
end class;
define sealed domain make (singleton(CORBA/InterfaceDef/<FullInterfaceDescription>));
define sealed domain initialize (CORBA/InterfaceDef/<FullInterfaceDescription>);

define constant CORBA/InterfaceDef/$FullInterfaceDescription-typecode = make(<struct-typecode>, type: CORBA/InterfaceDef/<FullInterfaceDescription>, name: "FullInterfaceDescription", repository-id: "IDL:omg.org/CORBA/InterfaceDef/FullInterfaceDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/InterfaceDef/FullInterfaceDescription/name, setter: CORBA/InterfaceDef/FullInterfaceDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/InterfaceDef/FullInterfaceDescription/id, setter: CORBA/InterfaceDef/FullInterfaceDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/InterfaceDef/FullInterfaceDescription/defined-in, setter: CORBA/InterfaceDef/FullInterfaceDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/InterfaceDef/FullInterfaceDescription/version, setter: CORBA/InterfaceDef/FullInterfaceDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "operations", type: CORBA/<OpDescriptionSeq>, getter: CORBA/InterfaceDef/FullInterfaceDescription/operations, setter: CORBA/InterfaceDef/FullInterfaceDescription/operations-setter, init-keyword: operations:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<OperationDescription>), type: limited(CORBA/<sequence>, of: CORBA/<OperationDescription>), max-length: 0, element-typecode: class-typecode(CORBA/<OperationDescription>))), make(<typecode-member>, name: "attributes", type: CORBA/<AttrDescriptionSeq>, getter: CORBA/InterfaceDef/FullInterfaceDescription/attributes, setter: CORBA/InterfaceDef/FullInterfaceDescription/attributes-setter, init-keyword: attributes:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<AttributeDescription>), type: limited(CORBA/<sequence>, of: CORBA/<AttributeDescription>), max-length: 0, element-typecode: class-typecode(CORBA/<AttributeDescription>))), make(<typecode-member>, name: "base_interfaces", type: CORBA/<RepositoryIdSeq>, getter: CORBA/InterfaceDef/FullInterfaceDescription/base-interfaces, setter: CORBA/InterfaceDef/FullInterfaceDescription/base-interfaces-setter, init-keyword: base-interfaces:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<RepositoryId>), type: limited(CORBA/<sequence>, of: CORBA/<RepositoryId>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0))), make(<typecode-member>, name: "type", type: CORBA/<TypeCode>, getter: CORBA/InterfaceDef/FullInterfaceDescription/type, setter: CORBA/InterfaceDef/FullInterfaceDescription/type-setter, init-keyword: type:, typecode: class-typecode(CORBA/<TypeCode>))));

define method class-typecode (class == CORBA/InterfaceDef/<FullInterfaceDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/InterfaceDef/$FullInterfaceDescription-typecode;
end method;

define method object-typecode (object :: CORBA/InterfaceDef/<FullInterfaceDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/InterfaceDef/$FullInterfaceDescription-typecode;
end method;

define open generic CORBA/InterfaceDef/describe-interface (object :: CORBA/<InterfaceDef>)
 => (result :: CORBA/InterfaceDef/<FullInterfaceDescription>);

define open generic CORBA/InterfaceDef/create-attribute (object :: CORBA/<InterfaceDef>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, type :: CORBA/<IDLType>, mode :: CORBA/<AttributeMode>)
 => (result :: CORBA/<AttributeDef>);

define open generic CORBA/InterfaceDef/create-operation (object :: CORBA/<InterfaceDef>, id :: CORBA/<RepositoryId>, name :: CORBA/<Identifier>, version :: CORBA/<VersionSpec>, result :: CORBA/<IDLType>, mode :: CORBA/<OperationMode>, params :: CORBA/<ParDescriptionSeq>, exceptions :: CORBA/<ExceptionDefSeq>, contexts :: CORBA/<ContextIdSeq>)
 => (result :: CORBA/<OperationDef>);

define sealed class CORBA/<InterfaceDescription> (CORBA/<struct>)
  slot CORBA/InterfaceDescription/name :: CORBA/<Identifier>, required-init-keyword: name:;
  slot CORBA/InterfaceDescription/id :: CORBA/<RepositoryId>, required-init-keyword: id:;
  slot CORBA/InterfaceDescription/defined-in :: CORBA/<RepositoryId>, required-init-keyword: defined-in:;
  slot CORBA/InterfaceDescription/version :: CORBA/<VersionSpec>, required-init-keyword: version:;
  slot CORBA/InterfaceDescription/base-interfaces :: CORBA/<RepositoryIdSeq>, required-init-keyword: base-interfaces:;
end class;
define sealed domain make (singleton(CORBA/<InterfaceDescription>));
define sealed domain initialize (CORBA/<InterfaceDescription>);

define constant CORBA/$InterfaceDescription-typecode = make(<struct-typecode>, type: CORBA/<InterfaceDescription>, name: "InterfaceDescription", repository-id: "IDL:omg.org/CORBA/InterfaceDescription:1.0", members: vector(make(<typecode-member>, name: "name", type: CORBA/<Identifier>, getter: CORBA/InterfaceDescription/name, setter: CORBA/InterfaceDescription/name-setter, init-keyword: name:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "id", type: CORBA/<RepositoryId>, getter: CORBA/InterfaceDescription/id, setter: CORBA/InterfaceDescription/id-setter, init-keyword: id:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "defined_in", type: CORBA/<RepositoryId>, getter: CORBA/InterfaceDescription/defined-in, setter: CORBA/InterfaceDescription/defined-in-setter, init-keyword: defined-in:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "version", type: CORBA/<VersionSpec>, getter: CORBA/InterfaceDescription/version, setter: CORBA/InterfaceDescription/version-setter, init-keyword: version:, typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)), make(<typecode-member>, name: "base_interfaces", type: CORBA/<RepositoryIdSeq>, getter: CORBA/InterfaceDescription/base-interfaces, setter: CORBA/InterfaceDescription/base-interfaces-setter, init-keyword: base-interfaces:, typecode: make(<sequence-typecode>, type: limited(CORBA/<sequence>, of: CORBA/<RepositoryId>), type: limited(CORBA/<sequence>, of: CORBA/<RepositoryId>), max-length: 0, element-typecode: make(<string-typecode>, type: CORBA/<string>, max-length: 0)))));

define method class-typecode (class == CORBA/<InterfaceDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$InterfaceDescription-typecode;
end method;

define method object-typecode (object :: CORBA/<InterfaceDescription>)
 => (typecode :: <struct-typecode>)
  CORBA/$InterfaceDescription-typecode;
end method;


/* eof */
