module: dylan-user

define module remote-nub-protocol
  use common-dylan;
  use dylan-orb;
  use dylan-orb-internals;
  export
    Rtmgr/<AccessPath>,
    Rtmgr/AccessPath/<NUBINT>,
    Rtmgr/AccessPath/<RTARGET-ADDRESS>,
    Rtmgr/AccessPath/<RNUBPROCESS>,
    Rtmgr/AccessPath/<RNUBTHREAD>,
    Rtmgr/AccessPath/create-thread-stop-reason-handler,
    Rtmgr/AccessPath/debugger-message,
    Rtmgr/AccessPath/nub-debug-message,
    Rtmgr/AccessPath/debugger-error,
    Rtmgr/<RemoteNub>,
    Rtmgr/RemoteNub/<INT8>,
    Rtmgr/RemoteNub/<INT16>,
    Rtmgr/RemoteNub/<INT32>,
    Rtmgr/RemoteNub/<UNICODE>,
    Rtmgr/RemoteNub/<NUBINT>,
    Rtmgr/RemoteNub/<NUB-INDEX>,
    Rtmgr/RemoteNub/<NUB-ERROR>,
    Rtmgr/RemoteNub/<NUBFLOAT>,
    Rtmgr/RemoteNub/<NUBDOUBLE>,
    Rtmgr/RemoteNub/<TARGET-INT>,
    Rtmgr/RemoteNub/<RNUBHANDLE>,
    Rtmgr/RemoteNub/<RNUB>,
    Rtmgr/RemoteNub/<RSERVER>,
    Rtmgr/RemoteNub/<RNUBPROCESS>,
    Rtmgr/RemoteNub/<RNUBTHREAD>,
    Rtmgr/RemoteNub/<RNUBLIBRARY>,
    Rtmgr/RemoteNub/<RTARGET-ADDRESS>,
    Rtmgr/RemoteNub/<FLAG>,
    Rtmgr/RemoteNub/<RTARGET-ADDRESS-SEQ>,
    Rtmgr/RemoteNub/<STRING-SEQ>,
    Rtmgr/RemoteNub/process,
    Rtmgr/RemoteNub/access-path,
    Rtmgr/RemoteNub/create-and-debug-process,
    Rtmgr/RemoteNub/debug-active-process,
    Rtmgr/RemoteNub/remote-value-byte-size,
    Rtmgr/RemoteNub/get-process-page-fault-count,
    Rtmgr/RemoteNub/thread-os-priority,
    Rtmgr/RemoteNub/get-thread-cpu-time,
    Rtmgr/RemoteNub/get-library-base-address,
    Rtmgr/RemoteNub/get-library-version,
    Rtmgr/RemoteNub/get-library-filename,
    Rtmgr/RemoteNub/get-library-undecorated-name,
    Rtmgr/RemoteNub/get-register-name,
    Rtmgr/RemoteNub/get-register-enumeration-code,
    Rtmgr/RemoteNub/all-registers,
    Rtmgr/RemoteNub/general-registers,
    Rtmgr/RemoteNub/special-registers,
    Rtmgr/RemoteNub/floating-registers,
    Rtmgr/RemoteNub/page-read-permission,
    Rtmgr/RemoteNub/page-write-permission,
    Rtmgr/RemoteNub/page-relative-address,
    Rtmgr/RemoteNub/virtual-page-size,
    Rtmgr/RemoteNub/read-value-from-process-memory,
    Rtmgr/RemoteNub/write-value-to-process-memory,
    Rtmgr/RemoteNub/calculate-stack-address,
    Rtmgr/RemoteNub/target-address-to-string,
    Rtmgr/RemoteNub/string-to-target-address,
    Rtmgr/RemoteNub/read-single-float-from-process-memory,
    Rtmgr/RemoteNub/write-single-float-to-process-memory,
    Rtmgr/RemoteNub/read-double-float-from-process-memory,
    Rtmgr/RemoteNub/write-double-float-to-process-memory,
    Rtmgr/RemoteNub/read-byte-string-from-process-memory,
    Rtmgr/RemoteNub/write-byte-string-to-process-memory,
    Rtmgr/RemoteNub/read-value-from-process-register-in-stack-frame,
    Rtmgr/RemoteNub/read-value-from-process-register,
    Rtmgr/RemoteNub/write-value-to-process-register,
    Rtmgr/RemoteNub/read-single-float-from-process-register,
    Rtmgr/RemoteNub/write-single-float-to-process-register,
    Rtmgr/RemoteNub/read-double-float-from-process-register,
    Rtmgr/RemoteNub/write-double-float-to-process-register,
    Rtmgr/RemoteNub/application-restart,
    Rtmgr/RemoteNub/application-stop,
    Rtmgr/RemoteNub/application-continue,
    Rtmgr/RemoteNub/application-continue-unhandled,
    Rtmgr/RemoteNub/application-step,
    Rtmgr/RemoteNub/application-step-over,
    Rtmgr/RemoteNub/application-step-out,
    Rtmgr/RemoteNub/set-stepping-control-on-thread,
    Rtmgr/RemoteNub/clear-stepping-control-on-thread,
    Rtmgr/RemoteNub/thread-stop,
    Rtmgr/RemoteNub/thread-continue,
    Rtmgr/RemoteNub/thread-suspendedQ,
    Rtmgr/RemoteNub/thread-suspended,
    Rtmgr/RemoteNub/thread-resumed,
    Rtmgr/RemoteNub/kill-application,
    Rtmgr/RemoteNub/close-application,
    Rtmgr/RemoteNub/close-remote-tether,
    Rtmgr/RemoteNub/setup-function-call,
    Rtmgr/RemoteNub/remote-call-spy,
    Rtmgr/RemoteNub/get-function-result,
    Rtmgr/RemoteNub/restore-context,
    Rtmgr/RemoteNub/set-breakpoint,
    Rtmgr/RemoteNub/clear-breakpoint,
    Rtmgr/RemoteNub/query-breakpoint,
    Rtmgr/RemoteNub/wait-for-stop-reason-with-timeout,
    Rtmgr/RemoteNub/profile-wait-for-stop-reason-with-timeout,
    Rtmgr/RemoteNub/inform-profiling-started,
    Rtmgr/RemoteNub/inform-profiling-stopped,
    Rtmgr/RemoteNub/can-receive-first-chance,
    Rtmgr/RemoteNub/set-first-chance,
    Rtmgr/RemoteNub/unset-first-chance,
    Rtmgr/RemoteNub/thread-stop-information,
    Rtmgr/RemoteNub/wait-for-stop-reason-no-timeout,
    Rtmgr/RemoteNub/profile-wait-for-stop-reason-no-timeout,
    Rtmgr/RemoteNub/stop-reason-process,
    Rtmgr/RemoteNub/stop-reason-thread,
    Rtmgr/RemoteNub/first-hard-coded-breakpoint,
    Rtmgr/RemoteNub/stop-reason-process-exit-code,
    Rtmgr/RemoteNub/stop-reason-thread-exit-code,
    Rtmgr/RemoteNub/stop-reason-library,
    Rtmgr/RemoteNub/stop-reason-violation-op,
    Rtmgr/RemoteNub/exception-first-chance,
    Rtmgr/RemoteNub/stop-reason-violation-address,
    Rtmgr/RemoteNub/stop-reason-exception-address,
    Rtmgr/RemoteNub/stop-reason-debug-string-address,
    Rtmgr/RemoteNub/stop-reason-debug-string-length,
    Rtmgr/RemoteNub/stop-reason-debug-string-is-unicode,
    Rtmgr/RemoteNub/initialize-stack-vectors,
    Rtmgr/RemoteNub/read-stack-vectors,
    Rtmgr/RemoteNub/all-frame-lexicals,
    Rtmgr/RemoteNub/register-interactive-code-segment,
    Rtmgr/RemoteNub/get-lexical-variable-name,
    Rtmgr/RemoteNub/lexical-variable-address,
    Rtmgr/RemoteNub/lookup-symbol-name,
    Rtmgr/RemoteNub/lookup-symbol-address,
    Rtmgr/RemoteNub/lookup-function-debug-start,
    Rtmgr/RemoteNub/lookup-function-debug-end,
    Rtmgr/RemoteNub/lookup-symbol-language,
    Rtmgr/RemoteNub/lookup-function-end,
    Rtmgr/RemoteNub/symbol-is-function,
    Rtmgr/RemoteNub/nearest-symbols,
    Rtmgr/RemoteNub/closest-symbol,
    Rtmgr/RemoteNub/function-bounding-addresses,
    Rtmgr/RemoteNub/closest-symbol-name,
    Rtmgr/RemoteNub/find-symbol-in-library,
    Rtmgr/RemoteNub/dispose-lookups,
    Rtmgr/RemoteNub/resolve-source-location,
    Rtmgr/RemoteNub/fetch-source-locations,
    Rtmgr/RemoteNub/source-location-address,
    Rtmgr/RemoteNub/source-location-linenumber,
    Rtmgr/RemoteNub/source-location-filename,
    Rtmgr/RemoteNub/number-of-source-locations,
    Rtmgr/RemoteNub/dispose-source-locations,
    Rtmgr/RemoteNub/interpret-instruction-at-current-location,
    Rtmgr/RemoteNub/dylan-calculate-step-into,
    Rtmgr/RemoteNub/dylan-thread-environment-block-address,
    Rtmgr/RemoteNub/dylan-thread-mv-buffer-live,
    Rtmgr/RemoteNub/older-stack-frame,
    Rtmgr/RemoteNub/dylan-current-function,
    Rtmgr/RemoteNub/perform-absolute-relocation,
    Rtmgr/RemoteNub/perform-relative-relocation,
    Rtmgr/RemoteNub/recover-breakpoint,
    Rtmgr/RemoteNub/get-process-wall-clock-time,
    Rtmgr/RemoteNub/register-exit-process-function,
    Rtmgr/RemoteNub/open-local-tether,
    Rtmgr/RemoteNub/attach-local-tether,
    Rtmgr/RemoteNub/OpenNub,
    Rtmgr/RemoteNub/CloseNub,
    Rtmgr/<NubServer>,
    Rtmgr/NubServer/<NUBINT>,
    Rtmgr/NubServer/<NUB-INDEX>,
    Rtmgr/NubServer/<RNUB>,
    Rtmgr/NubServer/<RNUBPROCESS>,
    Rtmgr/NubServer/<RemoteNub-SEQ>,
    Rtmgr/NubServer/nubs,
    Rtmgr/NubServer/CreateNub,
    Rtmgr/NubServer/DestroyNub,
    Rtmgr/NubServer/RegisterNub,
    Rtmgr/NubServer/DeregisterNub,
    Rtmgr/NubServer/ShutdownServer,
    Rtmgr/NubServer/get-local-hostname,
    Rtmgr/NubServer/verify-local-password,
    Rtmgr/NubServer/update-local-process-list,
    Rtmgr/NubServer/local-process-nub-descriptor,
    Rtmgr/NubServer/local-process-identifier,
    Rtmgr/NubServer/local-process-name,
    Rtmgr/NubServer/local-process-system-identifier,
    Rtmgr/NubServer/local-process-actual-identifier;
end;

