module:    Dylan-user	
Synopsis:  Win32 API for multimedia from "MMSYSTEM.H" and "WINMM.DLL"
Copyright:    Original Code is Copyright (c) 1995-2004 Functional Objects, Inc.
              All rights reserved.
License:      See License.txt in this distribution for details.
Warranty:     Distributed WITHOUT WARRANTY OF ANY KIND


/* Automatically generated from "library.src"; do not edit. */

define library Win32-multimedia
  use dylan;
  use C-FFI;
  use Win32-common;
  use Win32-user;
  export Win32-multimedia;
end library;

define module Win32-multimedia
  use Dylan;
  use C-FFI,
    export: {null-pointer, null-pointer?, pointer-address,
	     pointer-value, pointer-value-setter, size-of,
	     pointer-cast, destroy, \with-stack-structure,
	     c-type-cast};
  use Win32-common,
    export: {// data types used as arguments and fields:
	     <HANDLE>, <HDC>, <HMODULE>, <HTASK>, <HWND>, 
	     <LPARAM>, <LPBYTE>, <LPCSTR>, <LPDWORD>, <LPSTR>,
	     <LPUINT>, <LPVOID>, <LPWORD>, <LRESULT>, <LPRECT>,
	     // fields of a RECT:
	     left-value, top-value, right-value, bottom-value, 
	     left-value-setter, top-value-setter,
	     right-value-setter, bottom-value-setter, 
	     // generics with methods defined in both libraries:
	     cb-value, cb-value-setter, cbSize-value, cbSize-value-setter,
	     dwFlags-value, dwFlags-value-setter,
	     dwSize-value, dwSize-value-setter,
	     lpData-value, lpData-value-setter,
	     u-value, u-value-setter};
  use Win32-user,
    export: {$SC-SCREENSAVE, dwStyle-value, dwStyle-value-setter,
	     hDC-value, hDC-value-setter, hWnd-value, hWnd-value-setter,
	     hWndParent-value, hWndParent-value-setter,
	     hwndOwner-value, hwndOwner-value-setter};


  // from "mmsystem.h":
  export $MAXPNAMELEN, $MAXERRORLENGTH, $MAX-JOYSTICKOEMVXDNAME,
	<MMVERSION>, <MMRESULT>, wType-value, wType-value-setter, ms-value,
	ms-value-setter, sample-value, sample-value-setter, ticks-value,
	ticks-value-setter, hour-value, hour-value-setter, min-value,
	min-value-setter, sec-value, sec-value-setter, frame-value,
	frame-value-setter, fps-value, fps-value-setter, dummy-value,
	dummy-value-setter, pad-array, pad-array-setter, pad-value,
	hour-value, hour-value-setter, min-value, min-value-setter,
	sec-value, sec-value-setter, frame-value, frame-value-setter,
	fps-value, fps-value-setter, dummy-value, dummy-value-setter,
	pad-array, pad-array-setter, pad-value, smpte-value,
	songptrpos-value, songptrpos-value-setter, songptrpos-value,
	songptrpos-value-setter, midi-value, ms-value, ms-value-setter,
	sample-value, sample-value-setter, ticks-value, ticks-value-setter,
	hour-value, hour-value-setter, min-value, min-value-setter,
	sec-value, sec-value-setter, frame-value, frame-value-setter,
	fps-value, fps-value-setter, dummy-value, dummy-value-setter,
	pad-array, pad-array-setter, pad-value, hour-value,
	hour-value-setter, min-value, min-value-setter, sec-value,
	sec-value-setter, frame-value, frame-value-setter, fps-value,
	fps-value-setter, dummy-value, dummy-value-setter, pad-array,
	pad-array-setter, pad-value, smpte-value, songptrpos-value,
	songptrpos-value-setter, songptrpos-value, songptrpos-value-setter,
	midi-value, <MMTIME>, <LPMMTIME>, <PMMTIME>, $TIME-MS, $TIME-SAMPLES,
	$TIME-BYTES, $TIME-SMPTE, $TIME-MIDI, $TIME-TICKS, MAKEFOURCC;
  export $MM-JOY1MOVE, $MM-JOY2MOVE, $MM-JOY1ZMOVE, $MM-JOY2ZMOVE,
	$MM-JOY1BUTTONDOWN, $MM-JOY2BUTTONDOWN, $MM-JOY1BUTTONUP,
	$MM-JOY2BUTTONUP, $MM-MCINOTIFY, $MM-WOM-OPEN, $MM-WOM-CLOSE,
	$MM-WOM-DONE, $MM-WIM-OPEN, $MM-WIM-CLOSE, $MM-WIM-DATA,
	$MM-MIM-OPEN, $MM-MIM-CLOSE, $MM-MIM-DATA, $MM-MIM-LONGDATA,
	$MM-MIM-ERROR, $MM-MIM-LONGERROR, $MM-MOM-OPEN, $MM-MOM-CLOSE,
	$MM-MOM-DONE, $MM-DRVM-OPEN, $MM-DRVM-CLOSE, $MM-DRVM-DATA,
	$MM-DRVM-ERROR, $MM-STREAM-OPEN, $MM-STREAM-CLOSE, $MM-STREAM-DONE,
	$MM-STREAM-ERROR, $MM-MOM-POSITIONCB, $MM-MCISIGNAL,
	$MM-MIM-MOREDATA, $MM-MIXM-LINE-CHANGE, $MM-MIXM-CONTROL-CHANGE;
  export $MMSYSERR-BASE, $WAVERR-BASE, $MIDIERR-BASE, $TIMERR-BASE,
	$JOYERR-BASE, $MCIERR-BASE, $MIXERR-BASE, $MCI-STRING-OFFSET,
	$MCI-VD-OFFSET, $MCI-CD-OFFSET, $MCI-WAVE-OFFSET, $MCI-SEQ-OFFSET;
  export $MMSYSERR-NOERROR, $MMSYSERR-ERROR, $MMSYSERR-BADDEVICEID,
	$MMSYSERR-NOTENABLED, $MMSYSERR-ALLOCATED, $MMSYSERR-INVALHANDLE,
	$MMSYSERR-NODRIVER, $MMSYSERR-NOMEM, $MMSYSERR-NOTSUPPORTED,
	$MMSYSERR-BADERRNUM, $MMSYSERR-INVALFLAG, $MMSYSERR-INVALPARAM,
	$MMSYSERR-HANDLEBUSY, $MMSYSERR-INVALIDALIAS, $MMSYSERR-BADDB,
	$MMSYSERR-KEYNOTFOUND, $MMSYSERR-READERROR, $MMSYSERR-WRITEERROR,
	$MMSYSERR-DELETEERROR, $MMSYSERR-VALNOTFOUND, $MMSYSERR-NODRIVERCB,
	$MMSYSERR-LASTERROR, <HDRVR>;
  export dwDCISize-value, dwDCISize-value-setter,
	lpszDCISectionName-value, lpszDCISectionName-value-setter,
	lpszDCIAliasName-value, lpszDCIAliasName-value-setter,
	dnDevNode-value, dnDevNode-value-setter, <DRVCONFIGINFOEX>,
	<LPDRVCONFIGINFOEX>, <PDRVCONFIGINFOEX>, $DRV-LOAD, $DRV-ENABLE,
	$DRV-OPEN, $DRV-CLOSE, $DRV-DISABLE, $DRV-FREE, $DRV-CONFIGURE,
	$DRV-QUERYCONFIGURE, $DRV-INSTALL, $DRV-REMOVE, $DRV-EXITSESSION,
	$DRV-POWER, $DRV-RESERVED, $DRV-USER, dwDCISize-value,
	dwDCISize-value-setter, lpszDCISectionName-value,
	lpszDCISectionName-value-setter, lpszDCIAliasName-value,
	lpszDCIAliasName-value-setter, <DRVCONFIGINFO>, <LPDRVCONFIGINFO>,
	<PDRVCONFIGINFO>, $DRVCNF-CANCEL, $DRVCNF-OK, $DRVCNF-RESTART,
	<DRIVERPROC>, <DRIVERPROC>-callback-wrapper, CloseDriver, OpenDriver,
	SendDriverMessage, DrvGetModuleHandle, GetDriverModuleHandle,
	DefDriverProc, $DRV-CANCEL, $DRV-OK, $DRV-RESTART, $DRV-MCI-FIRST;
  export $CALLBACK-TYPEMASK, $CALLBACK-NULL, $CALLBACK-WINDOW,
	$CALLBACK-TASK, $CALLBACK-FUNCTION, $CALLBACK-THREAD,
	$CALLBACK-EVENT, <LPDRVCALLBACK>, <LPDRVCALLBACK>-callback-wrapper,
	<PDRVCALLBACK>;
  export sndPlaySound;
  export $SND-SYNC, $SND-ASYNC, $SND-NODEFAULT, $SND-MEMORY,
	$SND-LOOP, $SND-NOSTOP, $SND-NOWAIT, $SND-ALIAS, $SND-ALIAS-ID,
	$SND-FILENAME, $SND-RESOURCE, $SND-PURGE, $SND-APPLICATION,
	$SND-ALIAS-START, PlaySound;
  export $WAVERR-BADFORMAT, $WAVERR-STILLPLAYING, $WAVERR-UNPREPARED,
	$WAVERR-SYNC, $WAVERR-LASTERROR, <HWAVE>, <HWAVEIN>, <HWAVEOUT>,
	<LPHWAVEIN>, <LPHWAVEOUT>, <LPWAVECALLBACK>,
	<LPWAVECALLBACK>-callback-wrapper, $WOM-OPEN, $WOM-CLOSE, $WOM-DONE,
	$WIM-OPEN, $WIM-CLOSE, $WIM-DATA, $WAVE-MAPPER, $WAVE-FORMAT-QUERY,
	$WAVE-ALLOWSYNC, $WAVE-MAPPED, $WAVE-FORMAT-DIRECT,
	$WAVE-FORMAT-DIRECT-QUERY, dwBufferLength-value,
	dwBufferLength-value-setter, dwBytesRecorded-value,
	dwBytesRecorded-value-setter, dwUser-value, dwUser-value-setter,
	dwLoops-value, dwLoops-value-setter, lpNext-value,
	lpNext-value-setter, reserved-value, reserved-value-setter,
	<WAVEHDR>, <LPWAVEHDR>, <PWAVEHDR>, $WHDR-DONE, $WHDR-PREPARED,
	$WHDR-BEGINLOOP, $WHDR-ENDLOOP, $WHDR-INQUEUE, wMid-value,
	wMid-value-setter, wPid-value, wPid-value-setter,
	vDriverVersion-value, vDriverVersion-value-setter, szPname-array,
	szPname-array-setter, szPname-value, dwFormats-value,
	dwFormats-value-setter, wChannels-value, wChannels-value-setter,
	dwSupport-value, dwSupport-value-setter, <WAVEOUTCAPSA>,
	<LPWAVEOUTCAPSA>, <PWAVEOUTCAPSA>, <WAVEOUTCAPS>, <PWAVEOUTCAPS>,
	<LPWAVEOUTCAPS>, $WAVECAPS-PITCH, $WAVECAPS-PLAYBACKRATE,
	$WAVECAPS-VOLUME, $WAVECAPS-LRVOLUME, $WAVECAPS-SYNC,
	$WAVECAPS-SAMPLEACCURATE, $WAVECAPS-DIRECTSOUND, wMid-value,
	wMid-value-setter, wPid-value, wPid-value-setter,
	vDriverVersion-value, vDriverVersion-value-setter, szPname-array,
	szPname-array-setter, szPname-value, dwFormats-value,
	dwFormats-value-setter, wChannels-value, wChannels-value-setter,
	<WAVEINCAPSA>, <LPWAVEINCAPSA>, <PWAVEINCAPSA>, <WAVEINCAPS>,
	<PWAVEINCAPS>, <LPWAVEINCAPS>, $WAVE-INVALIDFORMAT,
	$WAVE-FORMAT-1M08, $WAVE-FORMAT-1S08, $WAVE-FORMAT-1M16,
	$WAVE-FORMAT-1S16, $WAVE-FORMAT-2M08, $WAVE-FORMAT-2S08,
	$WAVE-FORMAT-2M16, $WAVE-FORMAT-2S16, $WAVE-FORMAT-4M08,
	$WAVE-FORMAT-4S08, $WAVE-FORMAT-4M16, $WAVE-FORMAT-4S16,
	wFormatTag-value, wFormatTag-value-setter, nChannels-value,
	nChannels-value-setter, nSamplesPerSec-value,
	nSamplesPerSec-value-setter, nAvgBytesPerSec-value,
	nAvgBytesPerSec-value-setter, nBlockAlign-value,
	nBlockAlign-value-setter, <WAVEFORMAT>, <LPWAVEFORMAT>,
	<PWAVEFORMAT>, $WAVE-FORMAT-PCM, wf-value, wf-value-setter,
	wBitsPerSample-value, wBitsPerSample-value-setter, <PCMWAVEFORMAT>,
	<LPPCMWAVEFORMAT>, <PPCMWAVEFORMAT>, wFormatTag-value,
	wFormatTag-value-setter, nChannels-value, nChannels-value-setter,
	nSamplesPerSec-value, nSamplesPerSec-value-setter,
	nAvgBytesPerSec-value, nAvgBytesPerSec-value-setter,
	nBlockAlign-value, nBlockAlign-value-setter, wBitsPerSample-value,
	wBitsPerSample-value-setter, <WAVEFORMATEX>, <LPWAVEFORMATEX>,
	<PWAVEFORMATEX>, <LPCWAVEFORMATEX>, waveOutGetNumDevs,
	waveOutGetDevCaps, waveOutGetVolume, waveOutSetVolume,
	waveOutGetErrorText, waveOutOpen, waveOutClose, waveOutPrepareHeader,
	waveOutUnprepareHeader, waveOutWrite, waveOutPause, waveOutRestart,
	waveOutReset, waveOutBreakLoop, waveOutGetPosition, waveOutGetPitch,
	waveOutSetPitch, waveOutGetPlaybackRate, waveOutSetPlaybackRate,
	waveOutGetID, waveOutMessage, waveInGetNumDevs, waveInGetDevCaps,
	waveInGetErrorText, waveInOpen, waveInClose, waveInPrepareHeader,
	waveInUnprepareHeader, waveInAddBuffer, waveInStart, waveInStop,
	waveInReset, waveInGetPosition, waveInGetID, waveInMessage;
  export $MIDIERR-UNPREPARED, $MIDIERR-STILLPLAYING, $MIDIERR-NOMAP,
	$MIDIERR-NOTREADY, $MIDIERR-NODEVICE, $MIDIERR-INVALIDSETUP,
	$MIDIERR-BADOPENMODE, $MIDIERR-DONT-CONTINUE, $MIDIERR-LASTERROR,
	<HMIDI>, <HMIDIIN>, <HMIDIOUT>, <HMIDISTRM>, <LPHMIDI>, <LPHMIDIIN>,
	<LPHMIDIOUT>, <LPHMIDISTRM>, <LPMIDICALLBACK>,
	<LPMIDICALLBACK>-callback-wrapper, $MIDIPATCHSIZE, <LPPATCHARRAY>,
	<LPKEYARRAY>, $MIM-OPEN, $MIM-CLOSE, $MIM-DATA, $MIM-LONGDATA,
	$MIM-ERROR, $MIM-LONGERROR, $MOM-OPEN, $MOM-CLOSE, $MOM-DONE,
	$MIM-MOREDATA, $MOM-POSITIONCB, $MIDIMAPPER, $MIDI-MAPPER,
	$MIDI-IO-STATUS, $MIDI-CACHE-ALL, $MIDI-CACHE-BESTFIT,
	$MIDI-CACHE-QUERY, $MIDI-UNCACHE, wMid-value, wMid-value-setter,
	wPid-value, wPid-value-setter, vDriverVersion-value,
	vDriverVersion-value-setter, szPname-array, szPname-array-setter,
	szPname-value, wTechnology-value, wTechnology-value-setter,
	wVoices-value, wVoices-value-setter, wNotes-value,
	wNotes-value-setter, wChannelMask-value, wChannelMask-value-setter,
	dwSupport-value, dwSupport-value-setter, <MIDIOUTCAPSA>,
	<LPMIDIOUTCAPSA>, <PMIDIOUTCAPSA>, <MIDIOUTCAPS>, <PMIDIOUTCAPS>,
	<LPMIDIOUTCAPS>, $MOD-MIDIPORT, $MOD-SYNTH, $MOD-SQSYNTH,
	$MOD-FMSYNTH, $MOD-MAPPER, $MIDICAPS-VOLUME, $MIDICAPS-LRVOLUME,
	$MIDICAPS-CACHE, $MIDICAPS-STREAM, wMid-value, wMid-value-setter,
	wPid-value, wPid-value-setter, vDriverVersion-value,
	vDriverVersion-value-setter, szPname-array, szPname-array-setter,
	szPname-value, dwSupport-value, dwSupport-value-setter,
	<MIDIINCAPSA>, <LPMIDIINCAPSA>, <PMIDIINCAPSA>, <MIDIINCAPS>,
	<PMIDIINCAPS>, <LPMIDIINCAPS>, dwBufferLength-value,
	dwBufferLength-value-setter, dwBytesRecorded-value,
	dwBytesRecorded-value-setter, dwUser-value, dwUser-value-setter,
	lpNext-value, lpNext-value-setter, reserved-value,
	reserved-value-setter, dwOffset-value, dwOffset-value-setter,
	dwReserved-array, dwReserved-array-setter, dwReserved-value,
	<MIDIHDR>, <LPMIDIHDR>, <PMIDIHDR>, dwDeltaTime-value,
	dwDeltaTime-value-setter, dwStreamID-value, dwStreamID-value-setter,
	dwEvent-value, dwEvent-value-setter, dwParms-array,
	dwParms-array-setter, dwParms-value, <MIDIEVENT>, <LPMIDIEVENT>;
  export dwVersion-value, dwVersion-value-setter, dwMid-value,
	dwMid-value-setter, dwOEMVersion-value, dwOEMVersion-value-setter,
	<MIDISTRMBUFFVER>, <LPMIDISTRMBUFFVER>, $MHDR-DONE, $MHDR-PREPARED,
	$MHDR-INQUEUE, $MHDR-ISSTRM, $MEVT-F-SHORT, $MEVT-F-LONG,
	$MEVT-F-CALLBACK, MEVT-EVENTTYPE, MEVT-EVENTPARM, $MEVT-SHORTMSG,
	$MEVT-TEMPO, $MEVT-NOP, $MEVT-LONGMSG, $MEVT-COMMENT, $MEVT-VERSION,
	$MIDISTRM-ERROR, $MIDIPROP-SET, $MIDIPROP-GET, $MIDIPROP-TIMEDIV,
	$MIDIPROP-TEMPO, cbStruct-value, cbStruct-value-setter,
	dwTimeDiv-value, dwTimeDiv-value-setter, <MIDIPROPTIMEDIV>,
	<LPMIDIPROPTIMEDIV>;
  export cbStruct-value, cbStruct-value-setter, dwTempo-value,
	dwTempo-value-setter, <MIDIPROPTEMPO>, <LPMIDIPROPTEMPO>,
	midiOutGetNumDevs, midiStreamOpen, midiStreamClose,
	midiStreamProperty, midiStreamPosition, midiStreamOut,
	midiStreamPause, midiStreamRestart, midiStreamStop, midiConnect,
	midiDisconnect, midiOutGetDevCaps, midiOutGetVolume,
	midiOutSetVolume, midiOutGetErrorText, midiOutOpen, midiOutClose,
	midiOutPrepareHeader, midiOutUnprepareHeader, midiOutShortMsg,
	midiOutLongMsg, midiOutReset, midiOutCachePatches,
	midiOutCacheDrumPatches, midiOutGetID, midiOutMessage,
	midiInGetNumDevs, midiInGetDevCaps, midiInGetErrorText, midiInOpen,
	midiInClose, midiInPrepareHeader, midiInUnprepareHeader,
	midiInAddBuffer, midiInStart, midiInStop, midiInReset, midiInGetID,
	midiInMessage;
  export $AUX-MAPPER, wMid-value, wMid-value-setter, wPid-value,
	wPid-value-setter, vDriverVersion-value, vDriverVersion-value-setter,
	szPname-array, szPname-array-setter, szPname-value,
	wTechnology-value, wTechnology-value-setter, dwSupport-value,
	dwSupport-value-setter, <AUXCAPSA>, <LPAUXCAPSA>, <PAUXCAPSA>,
	<AUXCAPS>, <PAUXCAPS>, <LPAUXCAPS>, $AUXCAPS-CDAUDIO, $AUXCAPS-AUXIN,
	$AUXCAPS-VOLUME, $AUXCAPS-LRVOLUME, auxGetNumDevs, auxGetDevCaps,
	auxSetVolume, auxGetVolume, auxOutMessage;
  export <HMIXEROBJ>, <LPHMIXEROBJ>, <HMIXER>, <LPHMIXER>,
	$MIXER-SHORT-NAME-CHARS, $MIXER-LONG-NAME-CHARS, $MIXERR-INVALLINE,
	$MIXERR-INVALCONTROL, $MIXERR-INVALVALUE, $MIXERR-LASTERROR,
	$MIXER-OBJECTF-HANDLE, $MIXER-OBJECTF-MIXER, $MIXER-OBJECTF-HMIXER,
	$MIXER-OBJECTF-WAVEOUT, $MIXER-OBJECTF-HWAVEOUT,
	$MIXER-OBJECTF-WAVEIN, $MIXER-OBJECTF-HWAVEIN,
	$MIXER-OBJECTF-MIDIOUT, $MIXER-OBJECTF-HMIDIOUT,
	$MIXER-OBJECTF-MIDIIN, $MIXER-OBJECTF-HMIDIIN, $MIXER-OBJECTF-AUX,
	mixerGetNumDevs, wMid-value, wMid-value-setter, wPid-value,
	wPid-value-setter, vDriverVersion-value, vDriverVersion-value-setter,
	szPname-array, szPname-array-setter, szPname-value, fdwSupport-value,
	fdwSupport-value-setter, cDestinations-value,
	cDestinations-value-setter, <MIXERCAPSA>, <LPMIXERCAPSA>,
	<PMIXERCAPSA>, <MIXERCAPS>, <PMIXERCAPS>, <LPMIXERCAPS>,
	mixerGetDevCaps, mixerOpen, mixerClose, mixerMessage, cbStruct-value,
	cbStruct-value-setter, dwDestination-value,
	dwDestination-value-setter, dwSource-value, dwSource-value-setter,
	dwLineID-value, dwLineID-value-setter, fdwLine-value,
	fdwLine-value-setter, dwUser-value, dwUser-value-setter,
	dwComponentType-value, dwComponentType-value-setter, cChannels-value,
	cChannels-value-setter, cConnections-value,
	cConnections-value-setter, cControls-value, cControls-value-setter,
	szShortName-array, szShortName-array-setter, szShortName-value,
	szName-array, szName-array-setter, szName-value, dwType-value,
	dwType-value-setter, dwDeviceID-value, dwDeviceID-value-setter,
	wMid-value, wMid-value-setter, wPid-value, wPid-value-setter,
	vDriverVersion-value, vDriverVersion-value-setter, szPname-array,
	szPname-array-setter, szPname-value, dwType-value,
	dwType-value-setter, dwDeviceID-value, dwDeviceID-value-setter,
	wMid-value, wMid-value-setter, wPid-value, wPid-value-setter,
	vDriverVersion-value, vDriverVersion-value-setter, szPname-array,
	szPname-array-setter, szPname-value, Target-value, <MIXERLINEA>,
	<LPMIXERLINEA>, <PMIXERLINEA>, <MIXERLINE>, <PMIXERLINE>,
	<LPMIXERLINE>, $MIXERLINE-LINEF-ACTIVE,
	$MIXERLINE-LINEF-DISCONNECTED, $MIXERLINE-LINEF-SOURCE,
	$MIXERLINE-COMPONENTTYPE-DST-FIRST,
	$MIXERLINE-COMPONENTTYPE-DST-UNDEFINED,
	$MIXERLINE-COMPONENTTYPE-DST-DIGITAL,
	$MIXERLINE-COMPONENTTYPE-DST-LINE,
	$MIXERLINE-COMPONENTTYPE-DST-MONITOR,
	$MIXERLINE-COMPONENTTYPE-DST-SPEAKERS,
	$MIXERLINE-COMPONENTTYPE-DST-HEADPHONES,
	$MIXERLINE-COMPONENTTYPE-DST-TELEPHONE,
	$MIXERLINE-COMPONENTTYPE-DST-WAVEIN,
	$MIXERLINE-COMPONENTTYPE-DST-VOICEIN,
	$MIXERLINE-COMPONENTTYPE-DST-LAST,
	$MIXERLINE-COMPONENTTYPE-SRC-FIRST,
	$MIXERLINE-COMPONENTTYPE-SRC-UNDEFINED,
	$MIXERLINE-COMPONENTTYPE-SRC-DIGITAL,
	$MIXERLINE-COMPONENTTYPE-SRC-LINE,
	$MIXERLINE-COMPONENTTYPE-SRC-MICROPHONE,
	$MIXERLINE-COMPONENTTYPE-SRC-SYNTHESIZER,
	$MIXERLINE-COMPONENTTYPE-SRC-COMPACTDISC,
	$MIXERLINE-COMPONENTTYPE-SRC-TELEPHONE,
	$MIXERLINE-COMPONENTTYPE-SRC-PCSPEAKER,
	$MIXERLINE-COMPONENTTYPE-SRC-WAVEOUT,
	$MIXERLINE-COMPONENTTYPE-SRC-AUXILIARY,
	$MIXERLINE-COMPONENTTYPE-SRC-ANALOG,
	$MIXERLINE-COMPONENTTYPE-SRC-LAST, $MIXERLINE-TARGETTYPE-UNDEFINED,
	$MIXERLINE-TARGETTYPE-WAVEOUT, $MIXERLINE-TARGETTYPE-WAVEIN,
	$MIXERLINE-TARGETTYPE-MIDIOUT, $MIXERLINE-TARGETTYPE-MIDIIN,
	$MIXERLINE-TARGETTYPE-AUX, mixerGetLineInfo,
	$MIXER-GETLINEINFOF-DESTINATION, $MIXER-GETLINEINFOF-SOURCE,
	$MIXER-GETLINEINFOF-LINEID, $MIXER-GETLINEINFOF-COMPONENTTYPE,
	$MIXER-GETLINEINFOF-TARGETTYPE, $MIXER-GETLINEINFOF-QUERYMASK,
	mixerGetID, cbStruct-value, cbStruct-value-setter, dwControlID-value,
	dwControlID-value-setter, dwControlType-value,
	dwControlType-value-setter, fdwControl-value,
	fdwControl-value-setter, cMultipleItems-value,
	cMultipleItems-value-setter, szShortName-array,
	szShortName-array-setter, szShortName-value, szName-array,
	szName-array-setter, szName-value, Bounds-value, Bounds-value-setter,
	cSteps-value, cSteps-value-setter, cbCustomData-value,
	cbCustomData-value-setter, dwReserved-array, dwReserved-array-setter,
	dwReserved-value, cSteps-value, cSteps-value-setter,
	cbCustomData-value, cbCustomData-value-setter, dwReserved-array,
	dwReserved-array-setter, dwReserved-value, Metrics-value,
	Metrics-value-setter, <MIXERCONTROLA>, <LPMIXERCONTROLA>,
	<PMIXERCONTROLA>, <MIXERCONTROL>, <PMIXERCONTROL>, <LPMIXERCONTROL>,
	$MIXERCONTROL-CONTROLF-UNIFORM, $MIXERCONTROL-CONTROLF-MULTIPLE,
	$MIXERCONTROL-CONTROLF-DISABLED, $MIXERCONTROL-CT-CLASS-MASK,
	$MIXERCONTROL-CT-CLASS-CUSTOM, $MIXERCONTROL-CT-CLASS-METER,
	$MIXERCONTROL-CT-CLASS-SWITCH, $MIXERCONTROL-CT-CLASS-NUMBER,
	$MIXERCONTROL-CT-CLASS-SLIDER, $MIXERCONTROL-CT-CLASS-FADER,
	$MIXERCONTROL-CT-CLASS-TIME, $MIXERCONTROL-CT-CLASS-LIST,
	$MIXERCONTROL-CT-SUBCLASS-MASK, $MIXERCONTROL-CT-SC-SWITCH-BOOLEAN,
	$MIXERCONTROL-CT-SC-SWITCH-BUTTON, $MIXERCONTROL-CT-SC-METER-POLLED,
	$MIXERCONTROL-CT-SC-TIME-MICROSECS,
	$MIXERCONTROL-CT-SC-TIME-MILLISECS, $MIXERCONTROL-CT-SC-LIST-SINGLE,
	$MIXERCONTROL-CT-SC-LIST-MULTIPLE, $MIXERCONTROL-CT-UNITS-MASK,
	$MIXERCONTROL-CT-UNITS-CUSTOM, $MIXERCONTROL-CT-UNITS-BOOLEAN,
	$MIXERCONTROL-CT-UNITS-SIGNED, $MIXERCONTROL-CT-UNITS-UNSIGNED,
	$MIXERCONTROL-CT-UNITS-DECIBELS, $MIXERCONTROL-CT-UNITS-PERCENT,
	$MIXERCONTROL-CONTROLTYPE-CUSTOM,
	$MIXERCONTROL-CONTROLTYPE-BOOLEANMETER,
	$MIXERCONTROL-CONTROLTYPE-SIGNEDMETER,
	$MIXERCONTROL-CONTROLTYPE-PEAKMETER,
	$MIXERCONTROL-CONTROLTYPE-UNSIGNEDMETER,
	$MIXERCONTROL-CONTROLTYPE-BOOLEAN, $MIXERCONTROL-CONTROLTYPE-ONOFF,
	$MIXERCONTROL-CONTROLTYPE-MUTE, $MIXERCONTROL-CONTROLTYPE-MONO,
	$MIXERCONTROL-CONTROLTYPE-LOUDNESS,
	$MIXERCONTROL-CONTROLTYPE-STEREOENH,
	$MIXERCONTROL-CONTROLTYPE-BUTTON, $MIXERCONTROL-CONTROLTYPE-DECIBELS,
	$MIXERCONTROL-CONTROLTYPE-SIGNED, $MIXERCONTROL-CONTROLTYPE-UNSIGNED,
	$MIXERCONTROL-CONTROLTYPE-PERCENT, $MIXERCONTROL-CONTROLTYPE-SLIDER,
	$MIXERCONTROL-CONTROLTYPE-PAN, $MIXERCONTROL-CONTROLTYPE-QSOUNDPAN,
	$MIXERCONTROL-CONTROLTYPE-FADER, $MIXERCONTROL-CONTROLTYPE-VOLUME,
	$MIXERCONTROL-CONTROLTYPE-BASS, $MIXERCONTROL-CONTROLTYPE-TREBLE,
	$MIXERCONTROL-CONTROLTYPE-EQUALIZER,
	$MIXERCONTROL-CONTROLTYPE-SINGLESELECT,
	$MIXERCONTROL-CONTROLTYPE-MUX,
	$MIXERCONTROL-CONTROLTYPE-MULTIPLESELECT,
	$MIXERCONTROL-CONTROLTYPE-MIXER, $MIXERCONTROL-CONTROLTYPE-MICROTIME,
	$MIXERCONTROL-CONTROLTYPE-MILLITIME, cbStruct-value,
	cbStruct-value-setter, dwLineID-value, dwLineID-value-setter,
	dwControlID-value, dwControlID-value-setter, dwControlType-value,
	dwControlType-value-setter, cControls-value, cControls-value-setter,
	cbmxctrl-value, cbmxctrl-value-setter, pamxctrl-value,
	pamxctrl-value-setter, <MIXERLINECONTROLSA>, <LPMIXERLINECONTROLSA>,
	<PMIXERLINECONTROLSA>, <MIXERLINECONTROLS>, <PMIXERLINECONTROLS>,
	<LPMIXERLINECONTROLS>, mixerGetLineControls,
	$MIXER-GETLINECONTROLSF-ALL, $MIXER-GETLINECONTROLSF-ONEBYID,
	$MIXER-GETLINECONTROLSF-ONEBYTYPE, $MIXER-GETLINECONTROLSF-QUERYMASK,
	cbStruct-value, cbStruct-value-setter, dwControlID-value,
	dwControlID-value-setter, cChannels-value, cChannels-value-setter,
	cMultipleItems-value, cMultipleItems-value-setter, cbDetails-value,
	cbDetails-value-setter, paDetails-value, paDetails-value-setter,
	<MIXERCONTROLDETAILS>, <LPMIXERCONTROLDETAILS>,
	<PMIXERCONTROLDETAILS>, dwParam1-value, dwParam1-value-setter,
	dwParam2-value, dwParam2-value-setter, szName-array,
	szName-array-setter, szName-value, <MIXERCONTROLDETAILS-LISTTEXTA>,
	<LPMIXERCONTROLDETAILS-LISTTEXTA>, <PMIXERCONTROLDETAILS-LISTTEXTA>,
	<MIXERCONTROLDETAILS-LISTTEXT>, <PMIXERCONTROLDETAILS-LISTTEXT>,
	<LPMIXERCONTROLDETAILS-LISTTEXT>, fValue-value, fValue-value-setter,
	<MIXERCONTROLDETAILS-BOOLEAN>, <LPMIXERCONTROLDETAILS-BOOLEAN>,
	<PMIXERCONTROLDETAILS-BOOLEAN>;
  export lValue-value, lValue-value-setter,
	<MIXERCONTROLDETAILS-SIGNED>, <LPMIXERCONTROLDETAILS-SIGNED>,
	<PMIXERCONTROLDETAILS-SIGNED>;
  export dwValue-value, dwValue-value-setter,
	<MIXERCONTROLDETAILS-UNSIGNED>, <LPMIXERCONTROLDETAILS-UNSIGNED>,
	<PMIXERCONTROLDETAILS-UNSIGNED>, mixerGetControlDetails,
	$MIXER-GETCONTROLDETAILSF-VALUE, $MIXER-GETCONTROLDETAILSF-LISTTEXT,
	$MIXER-GETCONTROLDETAILSF-QUERYMASK, mixerSetControlDetails,
	$MIXER-SETCONTROLDETAILSF-VALUE, $MIXER-SETCONTROLDETAILSF-CUSTOM,
	$MIXER-SETCONTROLDETAILSF-QUERYMASK;
  export $TIMERR-NOERROR, $TIMERR-NOCANDO, $TIMERR-STRUCT,
	<LPTIMECALLBACK>, <LPTIMECALLBACK>-callback-wrapper, $TIME-ONESHOT,
	$TIME-PERIODIC, $TIME-CALLBACK-FUNCTION, $TIME-CALLBACK-EVENT-SET,
	$TIME-CALLBACK-EVENT-PULSE, wPeriodMin-value,
	wPeriodMin-value-setter, wPeriodMax-value, wPeriodMax-value-setter,
	<TIMECAPS>, <LPTIMECAPS>, <PTIMECAPS>, timeGetSystemTime,
	timeGetTime, timeSetEvent, timeKillEvent, timeGetDevCaps,
	timeBeginPeriod, timeEndPeriod;
  export $JOYERR-NOERROR, $JOYERR-PARMS, $JOYERR-NOCANDO,
	$JOYERR-UNPLUGGED, $JOY-BUTTON1, $JOY-BUTTON2, $JOY-BUTTON3,
	$JOY-BUTTON4, $JOY-BUTTON1CHG, $JOY-BUTTON2CHG, $JOY-BUTTON3CHG,
	$JOY-BUTTON4CHG, $JOY-BUTTON5, $JOY-BUTTON6, $JOY-BUTTON7,
	$JOY-BUTTON8, $JOY-BUTTON9, $JOY-BUTTON10, $JOY-BUTTON11,
	$JOY-BUTTON12, $JOY-BUTTON13, $JOY-BUTTON14, $JOY-BUTTON15,
	$JOY-BUTTON16, $JOY-BUTTON17, $JOY-BUTTON18, $JOY-BUTTON19,
	$JOY-BUTTON20, $JOY-BUTTON21, $JOY-BUTTON22, $JOY-BUTTON23,
	$JOY-BUTTON24, $JOY-BUTTON25, $JOY-BUTTON26, $JOY-BUTTON27,
	$JOY-BUTTON28, $JOY-BUTTON29, $JOY-BUTTON30, $JOY-BUTTON31,
	$JOY-BUTTON32, $JOY-POVFORWARD, $JOY-POVRIGHT, $JOY-POVBACKWARD,
	$JOY-POVLEFT, $JOY-RETURNX, $JOY-RETURNY, $JOY-RETURNZ, $JOY-RETURNR,
	$JOY-RETURNU, $JOY-RETURNV, $JOY-RETURNPOV, $JOY-RETURNBUTTONS,
	$JOY-RETURNRAWDATA, $JOY-RETURNPOVCTS, $JOY-RETURNCENTERED,
	$JOY-USEDEADZONE, $JOY-RETURNALL, $JOY-CAL-READALWAYS,
	$JOY-CAL-READXYONLY, $JOY-CAL-READ3, $JOY-CAL-READ4,
	$JOY-CAL-READXONLY, $JOY-CAL-READYONLY, $JOY-CAL-READ5,
	$JOY-CAL-READ6, $JOY-CAL-READZONLY, $JOY-CAL-READRONLY,
	$JOY-CAL-READUONLY, $JOY-CAL-READVONLY, $JOYSTICKID1, $JOYSTICKID2,
	$JOYCAPS-HASZ, $JOYCAPS-HASR, $JOYCAPS-HASU, $JOYCAPS-HASV,
	$JOYCAPS-HASPOV, $JOYCAPS-POV4DIR, $JOYCAPS-POVCTS, wMid-value,
	wMid-value-setter, wPid-value, wPid-value-setter, szPname-array,
	szPname-array-setter, szPname-value, wXmin-value, wXmin-value-setter,
	wXmax-value, wXmax-value-setter, wYmin-value, wYmin-value-setter,
	wYmax-value, wYmax-value-setter, wZmin-value, wZmin-value-setter,
	wZmax-value, wZmax-value-setter, wNumButtons-value,
	wNumButtons-value-setter, wPeriodMin-value, wPeriodMin-value-setter,
	wPeriodMax-value, wPeriodMax-value-setter, wRmin-value,
	wRmin-value-setter, wRmax-value, wRmax-value-setter, wUmin-value,
	wUmin-value-setter, wUmax-value, wUmax-value-setter, wVmin-value,
	wVmin-value-setter, wVmax-value, wVmax-value-setter, wCaps-value,
	wCaps-value-setter, wMaxAxes-value, wMaxAxes-value-setter,
	wNumAxes-value, wNumAxes-value-setter, wMaxButtons-value,
	wMaxButtons-value-setter, szRegKey-array, szRegKey-array-setter,
	szRegKey-value, szOEMVxD-array, szOEMVxD-array-setter,
	szOEMVxD-value, <JOYCAPSA>, <LPJOYCAPSA>, <PJOYCAPSA>, <JOYCAPS>,
	<PJOYCAPS>, <LPJOYCAPS>, wXpos-value, wXpos-value-setter,
	wYpos-value, wYpos-value-setter, wZpos-value, wZpos-value-setter,
	wButtons-value, wButtons-value-setter, <JOYINFO>, <LPJOYINFO>,
	<PJOYINFO>, dwXpos-value, dwXpos-value-setter, dwYpos-value,
	dwYpos-value-setter, dwZpos-value, dwZpos-value-setter, dwRpos-value,
	dwRpos-value-setter, dwUpos-value, dwUpos-value-setter, dwVpos-value,
	dwVpos-value-setter, dwButtons-value, dwButtons-value-setter,
	dwButtonNumber-value, dwButtonNumber-value-setter, dwPOV-value,
	dwPOV-value-setter, <JOYINFOEX>, <LPJOYINFOEX>, <PJOYINFOEX>,
	joyGetNumDevs, joyGetDevCaps, joyGetPos, joyGetPosEx,
	joyGetThreshold, joyReleaseCapture, joySetCapture, joySetThreshold;
  export $MMIOERR-BASE, $MMIOERR-FILENOTFOUND, $MMIOERR-OUTOFMEMORY,
	$MMIOERR-CANNOTOPEN, $MMIOERR-CANNOTCLOSE, $MMIOERR-CANNOTREAD,
	$MMIOERR-CANNOTWRITE, $MMIOERR-CANNOTSEEK, $MMIOERR-CANNOTEXPAND,
	$MMIOERR-CHUNKNOTFOUND, $MMIOERR-UNBUFFERED, $MMIOERR-PATHNOTFOUND,
	$MMIOERR-ACCESSDENIED, $MMIOERR-SHARINGVIOLATION,
	$MMIOERR-NETWORKERROR, $MMIOERR-TOOMANYOPENFILES,
	$MMIOERR-INVALIDFILE, <FOURCC>, <HPSTR>, <HMMIO>, <LPMMIOPROC>,
	<LPMMIOPROC>-callback-wrapper, fccIOProc-value,
	fccIOProc-value-setter, pIOProc-value, pIOProc-value-setter,
	wErrorRet-value, wErrorRet-value-setter, htask-value,
	htask-value-setter, cchBuffer-value, cchBuffer-value-setter,
	pchBuffer-value, pchBuffer-value-setter, pchNext-value,
	pchNext-value-setter, pchEndRead-value, pchEndRead-value-setter,
	pchEndWrite-value, pchEndWrite-value-setter, lBufOffset-value,
	lBufOffset-value-setter, lDiskOffset-value, lDiskOffset-value-setter,
	adwInfo-array, adwInfo-array-setter, adwInfo-value, hmmio-value,
	hmmio-value-setter, <MMIOINFO>, <LPMMIOINFO>, <PMMIOINFO>,
	<LPCMMIOINFO>, ckid-value, ckid-value-setter, cksize-value,
	cksize-value-setter, fccType-value, fccType-value-setter,
	dwDataOffset-value, dwDataOffset-value-setter, <MMCKINFO>,
	<LPMMCKINFO>, <PMMCKINFO>, <LPCMMCKINFO>, $MMIO-RWMODE,
	$MMIO-SHAREMODE, $MMIO-CREATE, $MMIO-PARSE, $MMIO-DELETE,
	$MMIO-EXIST, $MMIO-ALLOCBUF, $MMIO-GETTEMP, $MMIO-DIRTY, $MMIO-READ,
	$MMIO-WRITE, $MMIO-READWRITE, $MMIO-COMPAT, $MMIO-EXCLUSIVE,
	$MMIO-DENYWRITE, $MMIO-DENYREAD, $MMIO-DENYNONE, $MMIO-FHOPEN,
	$MMIO-EMPTYBUF, $MMIO-TOUPPER, $MMIO-INSTALLPROC, $MMIO-GLOBALPROC,
	$MMIO-REMOVEPROC, $MMIO-UNICODEPROC, $MMIO-FINDPROC, $MMIO-FINDCHUNK,
	$MMIO-FINDRIFF, $MMIO-FINDLIST, $MMIO-CREATERIFF, $MMIO-CREATELIST,
	$MMIOM-READ, $MMIOM-WRITE, $MMIOM-SEEK, $MMIOM-OPEN, $MMIOM-CLOSE,
	$MMIOM-WRITEFLUSH, $MMIOM-RENAME, $MMIOM-USER, $SEEK-SET, $SEEK-CUR,
	$SEEK-END, $MMIO-DEFAULTBUFFER, mmioFOURCC, mmioStringToFOURCC,
	mmioInstallIOProc, mmioOpen, mmioRename, mmioClose, mmioRead,
	mmioWrite, mmioSeek, mmioGetInfo, mmioSetInfo, mmioSetBuffer,
	mmioFlush, mmioAdvance, mmioSendMessage, mmioDescend, mmioAscend,
	mmioCreateChunk;
  export <MCIERROR>, <MCIDEVICEID>, <YIELDPROC>,
	<YIELDPROC>-callback-wrapper, mciSendCommand, mciSendString,
	mciGetDeviceID, mciGetDeviceIDFromElementID, mciGetErrorString,
	mciSetYieldProc, mciGetCreatorTask, mciGetYieldProc,
	$MCIERR-INVALID-DEVICE-ID, $MCIERR-UNRECOGNIZED-KEYWORD,
	$MCIERR-UNRECOGNIZED-COMMAND, $MCIERR-HARDWARE,
	$MCIERR-INVALID-DEVICE-NAME, $MCIERR-OUT-OF-MEMORY,
	$MCIERR-DEVICE-OPEN, $MCIERR-CANNOT-LOAD-DRIVER,
	$MCIERR-MISSING-COMMAND-STRING, $MCIERR-PARAM-OVERFLOW,
	$MCIERR-MISSING-STRING-ARGUMENT, $MCIERR-BAD-INTEGER,
	$MCIERR-PARSER-INTERNAL, $MCIERR-DRIVER-INTERNAL,
	$MCIERR-MISSING-PARAMETER, $MCIERR-UNSUPPORTED-FUNCTION,
	$MCIERR-FILE-NOT-FOUND, $MCIERR-DEVICE-NOT-READY, $MCIERR-INTERNAL,
	$MCIERR-DRIVER, $MCIERR-CANNOT-USE-ALL, $MCIERR-MULTIPLE,
	$MCIERR-EXTENSION-NOT-FOUND, $MCIERR-OUTOFRANGE,
	$MCIERR-FLAGS-NOT-COMPATIBLE, $MCIERR-FILE-NOT-SAVED,
	$MCIERR-DEVICE-TYPE-REQUIRED, $MCIERR-DEVICE-LOCKED,
	$MCIERR-DUPLICATE-ALIAS, $MCIERR-BAD-CONSTANT,
	$MCIERR-MUST-USE-SHAREABLE, $MCIERR-MISSING-DEVICE-NAME,
	$MCIERR-BAD-TIME-FORMAT, $MCIERR-NO-CLOSING-QUOTE,
	$MCIERR-DUPLICATE-FLAGS, $MCIERR-INVALID-FILE,
	$MCIERR-NULL-PARAMETER-BLOCK, $MCIERR-UNNAMED-RESOURCE,
	$MCIERR-NEW-REQUIRES-ALIAS, $MCIERR-NOTIFY-ON-AUTO-OPEN,
	$MCIERR-NO-ELEMENT-ALLOWED, $MCIERR-NONAPPLICABLE-FUNCTION,
	$MCIERR-ILLEGAL-FOR-AUTO-OPEN, $MCIERR-FILENAME-REQUIRED,
	$MCIERR-EXTRA-CHARACTERS, $MCIERR-DEVICE-NOT-INSTALLED,
	$MCIERR-GET-CD, $MCIERR-SET-CD, $MCIERR-SET-DRIVE,
	$MCIERR-DEVICE-LENGTH, $MCIERR-DEVICE-ORD-LENGTH, $MCIERR-NO-INTEGER,
	$MCIERR-WAVE-OUTPUTSINUSE, $MCIERR-WAVE-SETOUTPUTINUSE,
	$MCIERR-WAVE-INPUTSINUSE, $MCIERR-WAVE-SETINPUTINUSE,
	$MCIERR-WAVE-OUTPUTUNSPECIFIED, $MCIERR-WAVE-INPUTUNSPECIFIED,
	$MCIERR-WAVE-OUTPUTSUNSUITABLE, $MCIERR-WAVE-SETOUTPUTUNSUITABLE,
	$MCIERR-WAVE-INPUTSUNSUITABLE, $MCIERR-WAVE-SETINPUTUNSUITABLE,
	$MCIERR-SEQ-DIV-INCOMPATIBLE, $MCIERR-SEQ-PORT-INUSE,
	$MCIERR-SEQ-PORT-NONEXISTENT, $MCIERR-SEQ-PORT-MAPNODEVICE,
	$MCIERR-SEQ-PORT-MISCERROR, $MCIERR-SEQ-TIMER,
	$MCIERR-SEQ-PORTUNSPECIFIED, $MCIERR-SEQ-NOMIDIPRESENT,
	$MCIERR-NO-WINDOW, $MCIERR-CREATEWINDOW, $MCIERR-FILE-READ,
	$MCIERR-FILE-WRITE, $MCIERR-NO-IDENTITY, $MCIERR-CUSTOM-DRIVER-BASE,
	$MCI-FIRST, $MCI-OPEN, $MCI-CLOSE, $MCI-ESCAPE, $MCI-PLAY, $MCI-SEEK,
	$MCI-STOP, $MCI-PAUSE, $MCI-INFO, $MCI-GETDEVCAPS, $MCI-SPIN,
	$MCI-SET, $MCI-STEP, $MCI-RECORD, $MCI-SYSINFO, $MCI-BREAK,
	$MCI-SAVE, $MCI-STATUS, $MCI-CUE, $MCI-REALIZE, $MCI-WINDOW,
	$MCI-PUT, $MCI-WHERE, $MCI-FREEZE, $MCI-UNFREEZE, $MCI-LOAD,
	$MCI-CUT, $MCI-COPY, $MCI-PASTE, $MCI-UPDATE, $MCI-RESUME,
	$MCI-DELETE, $MCI-LAST, $MCI-ALL-DEVICE-ID, $MCI-DEVTYPE-VCR,
	$MCI-DEVTYPE-VIDEODISC, $MCI-DEVTYPE-OVERLAY, $MCI-DEVTYPE-CD-AUDIO,
	$MCI-DEVTYPE-DAT, $MCI-DEVTYPE-SCANNER, $MCI-DEVTYPE-ANIMATION,
	$MCI-DEVTYPE-DIGITAL-VIDEO, $MCI-DEVTYPE-OTHER,
	$MCI-DEVTYPE-WAVEFORM-AUDIO, $MCI-DEVTYPE-SEQUENCER,
	$MCI-DEVTYPE-FIRST, $MCI-DEVTYPE-LAST, $MCI-DEVTYPE-FIRST-USER,
	$MCI-MODE-NOT-READY, $MCI-MODE-STOP, $MCI-MODE-PLAY,
	$MCI-MODE-RECORD, $MCI-MODE-SEEK, $MCI-MODE-PAUSE, $MCI-MODE-OPEN,
	$MCI-FORMAT-MILLISECONDS, $MCI-FORMAT-HMS, $MCI-FORMAT-MSF,
	$MCI-FORMAT-FRAMES, $MCI-FORMAT-SMPTE-24, $MCI-FORMAT-SMPTE-25,
	$MCI-FORMAT-SMPTE-30, $MCI-FORMAT-SMPTE-30DROP, $MCI-FORMAT-BYTES,
	$MCI-FORMAT-SAMPLES, $MCI-FORMAT-TMSF, MCI-MSF-MINUTE,
	MCI-MSF-SECOND, MCI-MSF-FRAME, MCI-TMSF-TRACK, MCI-TMSF-MINUTE,
	MCI-TMSF-SECOND, MCI-TMSF-FRAME, MCI-HMS-HOUR, MCI-HMS-MINUTE,
	MCI-HMS-SECOND, $MCI-NOTIFY-SUCCESSFUL, $MCI-NOTIFY-SUPERSEDED,
	$MCI-NOTIFY-ABORTED, $MCI-NOTIFY-FAILURE, $MCI-NOTIFY, $MCI-WAIT,
	$MCI-FROM, $MCI-TO, $MCI-TRACK, $MCI-OPEN-SHAREABLE,
	$MCI-OPEN-ELEMENT, $MCI-OPEN-ALIAS, $MCI-OPEN-ELEMENT-ID,
	$MCI-OPEN-TYPE-ID, $MCI-OPEN-TYPE, $MCI-SEEK-TO-START,
	$MCI-SEEK-TO-END, $MCI-STATUS-ITEM, $MCI-STATUS-START,
	$MCI-STATUS-LENGTH, $MCI-STATUS-POSITION,
	$MCI-STATUS-NUMBER-OF-TRACKS, $MCI-STATUS-MODE,
	$MCI-STATUS-MEDIA-PRESENT, $MCI-STATUS-TIME-FORMAT,
	$MCI-STATUS-READY, $MCI-STATUS-CURRENT-TRACK, $MCI-INFO-PRODUCT,
	$MCI-INFO-FILE, $MCI-INFO-MEDIA-UPC, $MCI-INFO-MEDIA-IDENTITY,
	$MCI-INFO-NAME, $MCI-INFO-COPYRIGHT, $MCI-GETDEVCAPS-ITEM,
	$MCI-GETDEVCAPS-CAN-RECORD, $MCI-GETDEVCAPS-HAS-AUDIO,
	$MCI-GETDEVCAPS-HAS-VIDEO, $MCI-GETDEVCAPS-DEVICE-TYPE,
	$MCI-GETDEVCAPS-USES-FILES, $MCI-GETDEVCAPS-COMPOUND-DEVICE,
	$MCI-GETDEVCAPS-CAN-EJECT, $MCI-GETDEVCAPS-CAN-PLAY,
	$MCI-GETDEVCAPS-CAN-SAVE, $MCI-SYSINFO-QUANTITY, $MCI-SYSINFO-OPEN,
	$MCI-SYSINFO-NAME, $MCI-SYSINFO-INSTALLNAME, $MCI-SET-DOOR-OPEN,
	$MCI-SET-DOOR-CLOSED, $MCI-SET-TIME-FORMAT, $MCI-SET-AUDIO,
	$MCI-SET-VIDEO, $MCI-SET-ON, $MCI-SET-OFF, $MCI-SET-AUDIO-ALL,
	$MCI-SET-AUDIO-LEFT, $MCI-SET-AUDIO-RIGHT, $MCI-BREAK-KEY,
	$MCI-BREAK-HWND, $MCI-BREAK-OFF, $MCI-RECORD-INSERT,
	$MCI-RECORD-OVERWRITE, $MCI-SAVE-FILE, $MCI-LOAD-FILE,
	dwCallback-value, dwCallback-value-setter, <MCI-GENERIC-PARMS>,
	<LPMCI-GENERIC-PARMS>, <PMCI-GENERIC-PARMS>, dwCallback-value,
	dwCallback-value-setter, wDeviceID-value, wDeviceID-value-setter,
	lpstrDeviceType-value, lpstrDeviceType-value-setter,
	lpstrElementName-value, lpstrElementName-value-setter,
	lpstrAlias-value, lpstrAlias-value-setter, <MCI-OPEN-PARMSA>,
	<LPMCI-OPEN-PARMSA>, <PMCI-OPEN-PARMSA>, <MCI-OPEN-PARMS>,
	<PMCI-OPEN-PARMS>, <LPMCI-OPEN-PARMS>, dwCallback-value,
	dwCallback-value-setter, dwFrom-value, dwFrom-value-setter,
	dwTo-value, dwTo-value-setter, <MCI-PLAY-PARMS>, <LPMCI-PLAY-PARMS>,
	<PMCI-PLAY-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwTo-value, dwTo-value-setter, <MCI-SEEK-PARMS>, <LPMCI-SEEK-PARMS>,
	<PMCI-SEEK-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwReturn-value, dwReturn-value-setter, dwItem-value,
	dwItem-value-setter, dwTrack-value, dwTrack-value-setter,
	<MCI-STATUS-PARMS>, <LPMCI-STATUS-PARMS>, <PMCI-STATUS-PARMS>,
	dwCallback-value, dwCallback-value-setter, lpstrReturn-value,
	lpstrReturn-value-setter, dwRetSize-value, dwRetSize-value-setter,
	<MCI-INFO-PARMSA>, <LPMCI-INFO-PARMSA>, <MCI-INFO-PARMS>,
	<LPMCI-INFO-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwReturn-value, dwReturn-value-setter, dwItem-value,
	dwItem-value-setter, <MCI-GETDEVCAPS-PARMS>,
	<LPMCI-GETDEVCAPS-PARMS>, <PMCI-GETDEVCAPS-PARMS>, dwCallback-value,
	dwCallback-value-setter, lpstrReturn-value, lpstrReturn-value-setter,
	dwRetSize-value, dwRetSize-value-setter, dwNumber-value,
	dwNumber-value-setter, wDeviceType-value, wDeviceType-value-setter,
	<MCI-SYSINFO-PARMSA>, <LPMCI-SYSINFO-PARMSA>, <PMCI-SYSINFO-PARMSA>,
	<MCI-SYSINFO-PARMS>, <PMCI-SYSINFO-PARMS>, <LPMCI-SYSINFO-PARMS>,
	dwCallback-value, dwCallback-value-setter, dwTimeFormat-value,
	dwTimeFormat-value-setter, dwAudio-value, dwAudio-value-setter,
	<MCI-SET-PARMS>, <LPMCI-SET-PARMS>, <PMCI-SET-PARMS>,
	dwCallback-value, dwCallback-value-setter, nVirtKey-value,
	nVirtKey-value-setter, hwndBreak-value, hwndBreak-value-setter,
	<MCI-BREAK-PARMS>, <LPMCI-BREAK-PARMS>, <PMCI-BREAK-PARMS>,
	dwCallback-value, dwCallback-value-setter, lpfilename-value,
	lpfilename-value-setter, <MCI-SAVE-PARMSA>, <LPMCI-SAVE-PARMSA>,
	<PMCI-SAVE-PARMSA>, <MCI-SAVE-PARMS>, <PMCI-SAVE-PARMS>,
	<LPMCI-SAVE-PARMS>, dwCallback-value, dwCallback-value-setter,
	lpfilename-value, lpfilename-value-setter, <MCI-LOAD-PARMSA>,
	<LPMCI-LOAD-PARMSA>, <PMCI-LOAD-PARMSA>, <MCI-LOAD-PARMS>,
	<PMCI-LOAD-PARMS>, <LPMCI-LOAD-PARMS>, dwCallback-value,
	dwCallback-value-setter, dwFrom-value, dwFrom-value-setter,
	dwTo-value, dwTo-value-setter, <MCI-RECORD-PARMS>,
	<LPMCI-RECORD-PARMS>, $MCI-VD-MODE-PARK, $MCI-VD-MEDIA-CLV,
	$MCI-VD-MEDIA-CAV, $MCI-VD-MEDIA-OTHER, $MCI-VD-FORMAT-TRACK,
	$MCI-VD-PLAY-REVERSE, $MCI-VD-PLAY-FAST, $MCI-VD-PLAY-SPEED,
	$MCI-VD-PLAY-SCAN, $MCI-VD-PLAY-SLOW, $MCI-VD-SEEK-REVERSE,
	$MCI-VD-STATUS-SPEED, $MCI-VD-STATUS-FORWARD,
	$MCI-VD-STATUS-MEDIA-TYPE, $MCI-VD-STATUS-SIDE,
	$MCI-VD-STATUS-DISC-SIZE, $MCI-VD-GETDEVCAPS-CLV,
	$MCI-VD-GETDEVCAPS-CAV, $MCI-VD-SPIN-UP, $MCI-VD-SPIN-DOWN,
	$MCI-VD-GETDEVCAPS-CAN-REVERSE, $MCI-VD-GETDEVCAPS-FAST-RATE,
	$MCI-VD-GETDEVCAPS-SLOW-RATE, $MCI-VD-GETDEVCAPS-NORMAL-RATE,
	$MCI-VD-STEP-FRAMES, $MCI-VD-STEP-REVERSE, $MCI-VD-ESCAPE-STRING,
	dwCallback-value, dwCallback-value-setter, dwFrom-value,
	dwFrom-value-setter, dwTo-value, dwTo-value-setter, dwSpeed-value,
	dwSpeed-value-setter, <MCI-VD-PLAY-PARMS>, <LPMCI-VD-PLAY-PARMS>,
	<PMCI-VD-PLAY-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwFrames-value, dwFrames-value-setter, <MCI-VD-STEP-PARMS>,
	<LPMCI-VD-STEP-PARMS>, <PMCI-VD-STEP-PARMS>, dwCallback-value,
	dwCallback-value-setter, lpstrCommand-value,
	lpstrCommand-value-setter, <MCI-VD-ESCAPE-PARMSA>,
	<LPMCI-VD-ESCAPE-PARMSA>, <PMCI-VD-ESCAPE-PARMSA>,
	<MCI-VD-ESCAPE-PARMS>, <PMCI-VD-ESCAPE-PARMS>,
	<LPMCI-VD-ESCAPE-PARMS>, $MCI-CDA-STATUS-TYPE-TRACK,
	$MCI-CDA-TRACK-AUDIO, $MCI-CDA-TRACK-OTHER, $MCI-WAVE-PCM,
	$MCI-WAVE-MAPPER, $MCI-WAVE-OPEN-BUFFER, $MCI-WAVE-SET-FORMATTAG,
	$MCI-WAVE-SET-CHANNELS, $MCI-WAVE-SET-SAMPLESPERSEC,
	$MCI-WAVE-SET-AVGBYTESPERSEC, $MCI-WAVE-SET-BLOCKALIGN,
	$MCI-WAVE-SET-BITSPERSAMPLE, $MCI-WAVE-INPUT, $MCI-WAVE-OUTPUT,
	$MCI-WAVE-STATUS-FORMATTAG, $MCI-WAVE-STATUS-CHANNELS,
	$MCI-WAVE-STATUS-SAMPLESPERSEC, $MCI-WAVE-STATUS-AVGBYTESPERSEC,
	$MCI-WAVE-STATUS-BLOCKALIGN, $MCI-WAVE-STATUS-BITSPERSAMPLE,
	$MCI-WAVE-STATUS-LEVEL, $MCI-WAVE-SET-ANYINPUT,
	$MCI-WAVE-SET-ANYOUTPUT, $MCI-WAVE-GETDEVCAPS-INPUTS,
	$MCI-WAVE-GETDEVCAPS-OUTPUTS, dwCallback-value,
	dwCallback-value-setter, wDeviceID-value, wDeviceID-value-setter,
	lpstrDeviceType-value, lpstrDeviceType-value-setter,
	lpstrElementName-value, lpstrElementName-value-setter,
	lpstrAlias-value, lpstrAlias-value-setter, dwBufferSeconds-value,
	dwBufferSeconds-value-setter, <MCI-WAVE-OPEN-PARMSA>,
	<LPMCI-WAVE-OPEN-PARMSA>, <PMCI-WAVE-OPEN-PARMSA>,
	<MCI-WAVE-OPEN-PARMS>, <PMCI-WAVE-OPEN-PARMS>,
	<LPMCI-WAVE-OPEN-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwFrom-value, dwFrom-value-setter, dwTo-value, dwTo-value-setter,
	<MCI-WAVE-DELETE-PARMS>, <LPMCI-WAVE-DELETE-PARMS>,
	<PMCI-WAVE-DELETE-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwTimeFormat-value, dwTimeFormat-value-setter, dwAudio-value,
	dwAudio-value-setter, wInput-value, wInput-value-setter,
	wOutput-value, wOutput-value-setter, wFormatTag-value,
	wFormatTag-value-setter, nChannels-value, nChannels-value-setter,
	nSamplesPerSec-value, nSamplesPerSec-value-setter,
	nAvgBytesPerSec-value, nAvgBytesPerSec-value-setter,
	nBlockAlign-value, nBlockAlign-value-setter, wBitsPerSample-value,
	wBitsPerSample-value-setter, <MCI-WAVE-SET-PARMS>,
	<LPMCI-WAVE-SET-PARMS>, <PMCI-WAVE-SET-PARMS>,
	$MCI-SEQ-FORMAT-SONGPTR, $MCI-SEQ-FILE, $MCI-SEQ-MIDI,
	$MCI-SEQ-SMPTE, $MCI-SEQ-NONE, $MCI-SEQ-MAPPER,
	$MCI-SEQ-STATUS-TEMPO, $MCI-SEQ-STATUS-PORT, $MCI-SEQ-STATUS-SLAVE,
	$MCI-SEQ-STATUS-MASTER, $MCI-SEQ-STATUS-OFFSET,
	$MCI-SEQ-STATUS-DIVTYPE, $MCI-SEQ-STATUS-NAME,
	$MCI-SEQ-STATUS-COPYRIGHT, $MCI-SEQ-SET-TEMPO, $MCI-SEQ-SET-PORT,
	$MCI-SEQ-SET-SLAVE, $MCI-SEQ-SET-MASTER, $MCI-SEQ-SET-OFFSET,
	dwCallback-value, dwCallback-value-setter, dwTimeFormat-value,
	dwTimeFormat-value-setter, dwAudio-value, dwAudio-value-setter,
	dwTempo-value, dwTempo-value-setter, dwPort-value,
	dwPort-value-setter, dwSlave-value, dwSlave-value-setter,
	dwMaster-value, dwMaster-value-setter, dwOffset-value,
	dwOffset-value-setter, <MCI-SEQ-SET-PARMS>, <LPMCI-SEQ-SET-PARMS>,
	<PMCI-SEQ-SET-PARMS>, $MCI-ANIM-OPEN-WS, $MCI-ANIM-OPEN-PARENT,
	$MCI-ANIM-OPEN-NOSTATIC, $MCI-ANIM-PLAY-SPEED,
	$MCI-ANIM-PLAY-REVERSE, $MCI-ANIM-PLAY-FAST, $MCI-ANIM-PLAY-SLOW,
	$MCI-ANIM-PLAY-SCAN, $MCI-ANIM-STEP-REVERSE, $MCI-ANIM-STEP-FRAMES,
	$MCI-ANIM-STATUS-SPEED, $MCI-ANIM-STATUS-FORWARD,
	$MCI-ANIM-STATUS-HWND, $MCI-ANIM-STATUS-HPAL,
	$MCI-ANIM-STATUS-STRETCH, $MCI-ANIM-INFO-TEXT,
	$MCI-ANIM-GETDEVCAPS-CAN-REVERSE, $MCI-ANIM-GETDEVCAPS-FAST-RATE,
	$MCI-ANIM-GETDEVCAPS-SLOW-RATE, $MCI-ANIM-GETDEVCAPS-NORMAL-RATE,
	$MCI-ANIM-GETDEVCAPS-PALETTES, $MCI-ANIM-GETDEVCAPS-CAN-STRETCH,
	$MCI-ANIM-GETDEVCAPS-MAX-WINDOWS, $MCI-ANIM-REALIZE-NORM,
	$MCI-ANIM-REALIZE-BKGD, $MCI-ANIM-WINDOW-HWND,
	$MCI-ANIM-WINDOW-STATE, $MCI-ANIM-WINDOW-TEXT,
	$MCI-ANIM-WINDOW-ENABLE-STRETCH, $MCI-ANIM-WINDOW-DISABLE-STRETCH,
	$MCI-ANIM-WINDOW-DEFAULT, $MCI-ANIM-RECT, $MCI-ANIM-PUT-SOURCE,
	$MCI-ANIM-PUT-DESTINATION, $MCI-ANIM-WHERE-SOURCE,
	$MCI-ANIM-WHERE-DESTINATION, $MCI-ANIM-UPDATE-HDC, dwCallback-value,
	dwCallback-value-setter, wDeviceID-value, wDeviceID-value-setter,
	lpstrDeviceType-value, lpstrDeviceType-value-setter,
	lpstrElementName-value, lpstrElementName-value-setter,
	lpstrAlias-value, lpstrAlias-value-setter, <MCI-ANIM-OPEN-PARMSA>,
	<LPMCI-ANIM-OPEN-PARMSA>, <PMCI-ANIM-OPEN-PARMSA>,
	<MCI-ANIM-OPEN-PARMS>, <PMCI-ANIM-OPEN-PARMS>,
	<LPMCI-ANIM-OPEN-PARMS>, dwCallback-value, dwCallback-value-setter,
	dwFrom-value, dwFrom-value-setter, dwTo-value, dwTo-value-setter,
	dwSpeed-value, dwSpeed-value-setter, <MCI-ANIM-PLAY-PARMS>,
	<LPMCI-ANIM-PLAY-PARMS>, <PMCI-ANIM-PLAY-PARMS>, dwCallback-value,
	dwCallback-value-setter, dwFrames-value, dwFrames-value-setter,
	<MCI-ANIM-STEP-PARMS>, <LPMCI-ANIM-STEP-PARMS>,
	<PMCI-ANIM-STEP-PARMS>, dwCallback-value, dwCallback-value-setter,
	nCmdShow-value, nCmdShow-value-setter, lpstrText-value,
	lpstrText-value-setter, <MCI-ANIM-WINDOW-PARMSA>,
	<LPMCI-ANIM-WINDOW-PARMSA>, <PMCI-ANIM-WINDOW-PARMSA>,
	<MCI-ANIM-WINDOW-PARMS>, <PMCI-ANIM-WINDOW-PARMS>,
	<LPMCI-ANIM-WINDOW-PARMS>, dwCallback-value, dwCallback-value-setter,
	rc-value, rc-value-setter, <MCI-ANIM-RECT-PARMS>,
	<LPMCI-ANIM-RECT-PARMS>, <PMCI-ANIM-RECT-PARMS>, dwCallback-value,
	dwCallback-value-setter, rc-value, rc-value-setter,
	<MCI-ANIM-UPDATE-PARMS>, <LPMCI-ANIM-UPDATE-PARMS>,
	<PMCI-ANIM-UPDATE-PARMS>, $MCI-OVLY-OPEN-WS, $MCI-OVLY-OPEN-PARENT,
	$MCI-OVLY-STATUS-HWND, $MCI-OVLY-STATUS-STRETCH, $MCI-OVLY-INFO-TEXT,
	$MCI-OVLY-GETDEVCAPS-CAN-STRETCH, $MCI-OVLY-GETDEVCAPS-CAN-FREEZE,
	$MCI-OVLY-GETDEVCAPS-MAX-WINDOWS, $MCI-OVLY-WINDOW-HWND,
	$MCI-OVLY-WINDOW-STATE, $MCI-OVLY-WINDOW-TEXT,
	$MCI-OVLY-WINDOW-ENABLE-STRETCH, $MCI-OVLY-WINDOW-DISABLE-STRETCH,
	$MCI-OVLY-WINDOW-DEFAULT, $MCI-OVLY-RECT, $MCI-OVLY-PUT-SOURCE,
	$MCI-OVLY-PUT-DESTINATION, $MCI-OVLY-PUT-FRAME, $MCI-OVLY-PUT-VIDEO,
	$MCI-OVLY-WHERE-SOURCE, $MCI-OVLY-WHERE-DESTINATION,
	$MCI-OVLY-WHERE-FRAME, $MCI-OVLY-WHERE-VIDEO, dwCallback-value,
	dwCallback-value-setter, wDeviceID-value, wDeviceID-value-setter,
	lpstrDeviceType-value, lpstrDeviceType-value-setter,
	lpstrElementName-value, lpstrElementName-value-setter,
	lpstrAlias-value, lpstrAlias-value-setter, <MCI-OVLY-OPEN-PARMSA>,
	<LPMCI-OVLY-OPEN-PARMSA>, <PMCI-OVLY-OPEN-PARMSA>,
	<MCI-OVLY-OPEN-PARMS>, <PMCI-OVLY-OPEN-PARMS>,
	<LPMCI-OVLY-OPEN-PARMS>, dwCallback-value, dwCallback-value-setter,
	nCmdShow-value, nCmdShow-value-setter, lpstrText-value,
	lpstrText-value-setter, <MCI-OVLY-WINDOW-PARMSA>,
	<LPMCI-OVLY-WINDOW-PARMSA>, <PMCI-OVLY-WINDOW-PARMSA>,
	<MCI-OVLY-WINDOW-PARMS>, <PMCI-OVLY-WINDOW-PARMS>,
	<LPMCI-OVLY-WINDOW-PARMS>, dwCallback-value, dwCallback-value-setter,
	rc-value, rc-value-setter, <MCI-OVLY-RECT-PARMS>,
	<LPMCI-OVLY-RECT-PARMS>, <PMCI-OVLY-RECT-PARMS>, dwCallback-value,
	dwCallback-value-setter, lpfilename-value, lpfilename-value-setter,
	rc-value, rc-value-setter, <MCI-OVLY-SAVE-PARMSA>,
	<LPMCI-OVLY-SAVE-PARMSA>, <PMCI-OVLY-SAVE-PARMSA>,
	<MCI-OVLY-SAVE-PARMS>, <PMCI-OVLY-SAVE-PARMS>,
	<LPMCI-OVLY-SAVE-PARMS>, dwCallback-value, dwCallback-value-setter,
	lpfilename-value, lpfilename-value-setter, rc-value, rc-value-setter,
	<MCI-OVLY-LOAD-PARMSA>, <LPMCI-OVLY-LOAD-PARMSA>,
	<PMCI-OVLY-LOAD-PARMSA>, <MCI-OVLY-LOAD-PARMS>,
	<PMCI-OVLY-LOAD-PARMS>, <LPMCI-OVLY-LOAD-PARMS>;
  export $NEWTRANSPARENT, $QUERYROPSUPPORT;
  export $SELECTDIB, DIBINDEX;

  export <bounds-union*>;
  export lMinimum-value, lMaximum-value, dwMinimum-value, dwMaximum-value;
  export lMinimum-value-setter, lMaximum-value-setter,
    dwMinimum-value-setter, dwMaximum-value-setter;
  export sndAlias, MCI-MAKE-MSF, MCI-MAKE-TMSF, MCI-MAKE-HMS;

end module;
